############################################
##                                        ##
##              WebBBS Admin              ##
##           by Darryl Burgdorf           ##
##       (e-mail burgdorf@awsd.com)       ##
##                                        ##
##             version:  4.32             ##
##         last modified:  6/5/00         ##
##           copyright (c) 2000           ##
##                                        ##
##    latest version is available from    ##
##        http://awsd.com/scripts/        ##
##                                        ##
############################################

sub WebBBSAdmin {
	$private_list = $TopNPosters = $ArchiveOnly = 0;
	$LockRemoteUser = $ShowPosterIP = 0;
	$AdminRun = $DisplayEmail = $AllowURLs = $AllowPics = 1;
	$AllowUserDeletion = $AllowEmailNotices = $AllowPreview = 1;
	$AllowUserPrefs = $AllowNewThreads = $AllowResponses = 1;
	if ($ARGV[0] && !($ENV{'QUERY_STRING'})) {
		$ENV{'QUERY_STRING'} = $ARGV[0];
		$UseFrames = "";
		$SkipHF = 1;
	}
	if ($ENV{'QUERY_STRING'} =~ /profile/i) {
	  	require $webbbs_profile;
		&WebBBS;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /post/i) {
		require $webbbs_post;
		&Parse_Post;
	}
	else {
		&Parse_Form;
	}
	&Initialize_Data;
	unless ($shortboardname) { $shortboardname = $boardname; }
	if ((!($UseFrames) && ($ENV{'QUERY_STRING'} =~ /review=(\d+)/i)) 
	  || (!($UseFrames) && ($ENV{'QUERY_STRING'} =~ /rev=(\d+)/i)) 
	  || ($ENV{'QUERY_STRING'} =~ /read=(\d+)/i)) {
		$messagenumber = $1;
		if ($messagenumber < 1) { $messagenumber = $lastmessage; }
		require $webbbs_read;
		&DisplayMessage;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /checkdb/i) {
		&CheckDB;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /moderate=(\d+)/i) {
		$messagenumber = $1;
		if ($messagenumber < 1) {
			if ($UseFrames) {
				require $webbbs_index;
				&SetupFrames;
			}
			else { &Moderate; }
		}
		else { &ApprovePost; }
	}
	elsif ($ENV{'QUERY_STRING'} =~ /moderate/i) {
		&Moderate;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /topstats/i) {
		require $webbbs_misc;
		&TopStats;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /form=(\d+)/i) {
		$messagenumber = $1;
		require $webbbs_form;
		&PostForm;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /edit=(\d+)/i) {
		$messagenumber = $1;
		&PostEditForm;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /post/i) {
		&PostAdminMessage;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /resetpass/i) {
		&ResetPassword;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /addresslist/i) {
		require $webbbs_misc;
		&UpdateAddressList;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /subscribe/i) {
		require $webbbs_misc;
		&Subscribe;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /search/i) {
		require $webbbs_misc;
		&Search;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /reconfigure/i) {
		require $webbbs_misc;
		&Reconfigure;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /delete/i) {
		&AdminDelete;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /addresseditfinal/i) {
		&AddressEditFinal;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /addressedit/i) {
		&AddressEdit;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /bannededitfinal/i) {
		&BannedEditFinal;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /bannededit/i) {
		&BannedEdit;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /naughtyeditfinal/i) {
		&NaughtyEditFinal;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /naughtyedit/i) {
		&NaughtyEdit;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /blank/i) {
		require $webbbs_index;
		&BlankPage;
	}
	elsif ($UseFrames && ($ENV{'QUERY_STRING'} !~ /index/i)) {
		if (($ENV{'QUERY_STRING'} =~ /review=(\d+)/i)
		  || ($ENV{'QUERY_STRING'} =~ /rev=(\d+)/i)) {
			$message = $1;
			if ($message < 1) { $message = "00"; }
		}
		require $webbbs_index;
		&SetupFrames;
	}
	else {
		if (($ENV{'QUERY_STRING'} =~ /rebuilt/)
		  || (!($UseFrames) && $ENV{'QUERY_STRING'} =~ /rebuild/)) {
			$rebuildflag = 1;
			if ($DBMType==2) { dbmclose (%MessageList); }
			else { untie %MessageList; }
			require $webbbs_rebuild;
			&Rebuild_Database;
			@messages = (keys %MessageList);
			$TotalMessages = @messages;
			@sortedmessages = (sort {$a<=>$b} @messages);
			$lastmessage = $sortedmessages[@sortedmessages-1];
		}
		@messages = ();
		if ($FORM{'ListType'} =~ /Alpha/) {
			foreach $message (@sortedmessages) {
				$sortsubject{$message} = $MessageList{$message};
				$sortsubject{$message} =~ s/^[^\|]*\|([^\|]*).*/$1/;
				$sortsubject{$message} =~ s/^$text{'1513'} //;
				$sortsubject{$message} =~ s/&pipe;/\|/g;
				$sortsubject{$message} =~ tr/A-Z/a-z/;
			}
		}
		require $webbbs_index;
		&DisplayIndex;
	}
}

sub CheckDB {
	$DBTotal = @sortedmessages;
	$DBFirst = $sortedmessages[0];
	$DBLast = $sortedmessages[@sortedmessages-1];
	$PhysTotal = 0;
	$PhysFirst = 1000000000;
	$PhysLast = 0;
	opendir (MESSAGES,$dir);
	@messagedir = readdir(MESSAGES);
	closedir (MESSAGES);
	@messagecount = ();
	foreach $message (@messagedir) {
		next if ($message =~ /^\./);
		if ((-d "$dir/$message")
		  && ($message =~ /^bbs\d+/)) {
			opendir (COUNT,"$dir/$message");
			push (@messagecount,readdir(COUNT));
			closedir (COUNT);
		}
		else { push (@messagecount,"$message"); }
	}
	foreach $message (@messagecount) {
		next if (($message =~ /\.tmp$/) || ($message == 0));
		$PhysTotal++;
		if ($message > $PhysLast) { $PhysLast = $message; }
		if ($message < $PhysFirst) { $PhysFirst = $message; }
	}
	$SearchTotal = 0;
	$SearchFirst = 1000000000;
	$SearchLast = 0;
	open (SEARCH,"$dir/searchterms.idx");
	while (<SEARCH>) {
		if (/^(\d+) /) {
			$message = $1;
			$SearchTotal++;
			if ($message > $SearchLast) { $SearchLast = $message; }
			if ($message < $SearchFirst) { $SearchFirst = $message; }
		}
	}
	close (SEARCH);
	&Header($text{'8002'},$MessageHeaderFile);
	&Header2;
	print "<CENTER>\n",
	  "<P><BIG><BIG><STRONG>$text{'8002'}</STRONG></BIG></BIG>\n",
	  "<P><TABLE BORDER CELLPADDING=6><TR>\n",
	  "<TH></TH><TH>$text{'8003'}</TH>",
	  "<TH>$text{'8004'}</TH><TH>$text{'8005'}</TH></TR><TR>\n",
	  "<TH>$text{'8006'}</TH><TH>$PhysFirst</TH>",
	  "<TH>$PhysLast</TH><TH>$PhysTotal</TH></TR><TR>\n",
	  "<TH>$text{'8007'}</TH><TH>$DBFirst</TH>",
	  "<TH>$DBLast</TH><TH>$DBTotal</TH></TR><TR>\n",
	  "<TH>$text{'8008'}</TH><TH>$SearchFirst</TH>",
	  "<TH>$SearchLast</TH><TH>$SearchTotal</TH></TR>\n",
	  "</TABLE></CENTER>\n",
	  "<P>$text{'8009'}\n",
	  "<P ALIGN=CENTER><A HREF=\"$adminurl$BBSquery",
	  "rebuild\"$BBStargettop>$text{'8001'}</A>\n";
	&Footer($MessageFooterFile,"credits");
}

sub ApprovePost {
	$SpellCheckerMeta = 1;
	$subdir = "bbs".int($messagenumber/1000);
	open (FILE,"$dir/$subdir/$messagenumber.tmp") || &Error("9100","9101");
	@message = <FILE>;
	close (FILE);
	$subject=$poster=$email=$date=$ipaddress=$previous=$image_url=$linkname=$linkurl="";
	foreach $line (@message) {
		if ($line =~ /^SUBJECT>(.*)/i) { $subject = $1; }
		elsif ($line =~ /^ADMIN>/i) { next; }
		elsif ($line =~ /^POSTER>(.*)/i) { $poster = $1; }
		elsif ($line =~ /^EMAIL>(.*)/i) { $email = $1; }
		elsif ($line =~ /^DATE>(.*)/i) { $date = $1; }
		elsif ($line =~ /^EMAILNOTICES>/i) { next; }
		elsif ($line =~ /^IP_ADDRESS>(.*)/i) { $ipaddress = $1; }
		elsif ($line =~ /^<!--(.*)-->/i) { $remoteuser = $1; }
		elsif ($line =~ /^PASSWORD>/i) { next; }
		elsif ($line =~ /^PREVIOUS>(.*)/i) { $previous = $1; }
		elsif ($line =~ /^NEXT>/i) { next; }
		elsif ($line =~ /^IMAGE>(.*)/i) { $image_url = $1; }
		elsif ($line =~ /^LINKNAME>(.*)/i) { $linkname = $1; }
		elsif ($line =~ /^LINKURL>(.*)/i) { $linkurl = $1; }
		elsif (!$startup) {
			$startup = 1;
			$title = $subject;
			$title =~ s/<([^>]|\n)*>/ /g;
			&Header($title,$MessageHeaderFile);
			&Header2;
			unless ($UseFrames) {
				if ($printboardname) {
					print "<P ALIGN=CENTER><BIG><STRONG>";
					print "$boardname</STRONG></BIG>\n";
				}
			}
			print "<P ALIGN=CENTER><BIG><BIG><STRONG>";
			print "$subject</STRONG></BIG></BIG>\n";
			print "<P ALIGN=CENTER><STRONG>";
			print "$text{'1000'}: <BIG>$poster</BIG>";
			if ($remoteuser && ($remoteuser ne $poster)) {
				print " <EM>($remoteuser)</EM>";
			}
			if ($email) {
				$mailsubject = $subject;
				if (%SmileyCode) {
					foreach $key (keys %SmileyCode) {
						$key2 = $SmileyCode{$key};
						$key2 =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
						$mailsubject =~ s/$key2/$key/g;
					}
				}
				$mailsubject =~ s/"/'/g;
				print " &lt;<A HREF=\"mailto:$email?subject=$mailsubject\">";
				print "$email</A>&gt;";
			}
			if ($DisplayIPs && $ipaddress) {
				print " <SMALL><EM>($ipaddress)</EM></SMALL>\n";
			}
			print "<BR>$text{'1001'}: ",&PrintDate($date),"\n";
			if ($MessageList{$previous}>0) {
				$pdate=$psub=$pposter=$pprev=$pnext=$pcount=$padmin=$pip="";
				($pdate,$psub,$pposter,$pprev,$pnext,$pcount,$padmin,$pip) =
				  split(/\|/,$MessageList{$previous});
				$psub =~ s/&pipe;/\|/g;
				$pposter =~ s/&pipe;/\|/g;
				print "<P ALIGN=CENTER><EM>$text{'1002'}: ";
				print "<A HREF=\"$adminurl$BBSquery";
				print "read=$previous\"$BBStarget>";
				print "$psub</A> ";
				print "($pposter)</EM>\n";
			}
			print "</STRONG>$MessageOpenCode\n";
			print $line;
		}
		else { print $line; }
	}
	print "$MessageCloseCode\n";
	if ($image_url) {
		print "<P ALIGN=CENTER>";
		print "<IMG SRC=\"$image_url\">\n";
	}
	if ($linkurl) {
		print "<P ALIGN=CENTER>";
		print "<EM><A HREF=\"$linkurl\" ";
		print "TARGET=\"_blank\">";
		print "$linkname</A></EM>\n";
	}
	print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
	  "post\"$BBStargettop>\n",
	  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"ApprovePost\" ",
	  "VALUE=\"$messagenumber.tmp\">\n",
	  "<INPUT TYPE=SUBMIT VALUE=\"$text{'0702'}\"> ";
	unless ($BypassPassword) {	
		print "$text{'0206'}: </FONT><FONT FACE=\"Courier\">",
		  "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
		if ($FORM{'newpassword'}) {
			print "VALUE=\"$FORM{'newpassword'}\" ";
		}
		print "SIZE=15>";
	}
	print "$NavBarEnd</FORM>\n";
	$FormCount++;
	print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
	  "delete\"$BBStarget>\n",
	  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"DeleteConfirm\" ",
	  "VALUE=\"Yes\">\n",
	  "<INPUT TYPE=HIDDEN NAME=\"delete\" ",
	  "VALUE=\"$messagenumber.tmp\">\n",
	  "<INPUT TYPE=SUBMIT VALUE=\"$text{'0201'}\"> ";
	unless ($BypassPassword) {	
		print "$text{'0206'}: </FONT><FONT FACE=\"Courier\">",
		  "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
		if ($FORM{'newpassword'}) {
			print "VALUE=\"$FORM{'newpassword'}\" ";
		}
		print "SIZE=15>";
	}
	print "$NavBarEnd</FORM>\n";
	$FormCount++;
	&Print_EditForm($messagenumber);
	print "<P>&nbsp;";
	&Footer($MessageFooterFile,"credits");
}

sub AddressEdit {
	&Header($text{'0029'},$MessageHeaderFile);
	&Header2;
	open (ADDRESSES,"$dir/addresses.txt");
	@addresses = <ADDRESSES>;
	close (ADDRESSES);
	print "<CENTER>\n",
	  "<P><BIG><BIG><STRONG>$text{'0029'}</STRONG></BIG></BIG>\n",
	  "</CENTER>\n<P>$text{'0032'}\n<CENTER>\n",
	  "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
	  "addresseditfinal\"$BBStarget>",
	  "<P><FONT FACE=\"Courier\"><TEXTAREA COLS=$InputColumns ROWS=$InputRows ",
	  "NAME=\"listitems\" WRAP=VIRTUAL>";
	foreach $address (@addresses) { print "$address"; }
	print "</TEXTAREA></FONT>\n";
	unless ($BypassPassword) {	
		print "<P>$text{'0206'}: <FONT FACE=\"Courier\">",
		  "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
		if ($FORM{'newpassword'}) {
			print "VALUE=\"$FORM{'newpassword'}\" ";
		}
		print "SIZE=15></FONT>";
	}
	print "<P><INPUT TYPE=SUBMIT VALUE=\"$text{'0028'}\"> ";
	print "</FORM></CENTER>\n";
	&Footer($MessageFooterFile,"credits");
}

sub BannedEdit {
	&Header($text{'0027'},$MessageHeaderFile);
	&Header2;
	open (BANNED,"$BannedIPsFile");
	@bannedips = <BANNED>;
	close (BANNED);
	print "<CENTER>\n",
	  "<P><BIG><BIG><STRONG>$text{'0027'}</STRONG></BIG></BIG>\n",
	  "</CENTER>\n<P>$text{'0031'}\n<CENTER>\n",
	  "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
	  "bannededitfinal\"$BBStarget>",
	  "<P><FONT FACE=\"Courier\"><TEXTAREA COLS=$InputColumns ROWS=$InputRows ",
	  "NAME=\"listitems\" WRAP=VIRTUAL>";
	foreach $bannedip (@bannedips) { print "$bannedip"; }
	print "</TEXTAREA></FONT>\n";
	unless ($BypassPassword) {	
		print "<P>$text{'0206'}: <FONT FACE=\"Courier\">",
		  "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
		if ($FORM{'newpassword'}) {
			print "VALUE=\"$FORM{'newpassword'}\" ";
		}
		print "SIZE=15></FONT>";
	}
	print "<P><INPUT TYPE=SUBMIT VALUE=\"$text{'0028'}\"> ";
	print "</FORM></CENTER>\n";
	&Footer($MessageFooterFile,"credits");
}

sub NaughtyEdit {
	&Header($text{'0026'},$MessageHeaderFile);
	&Header2;
	open (NAUGHTY,"$NaughtyWordsFile");
	@naughtywords = <NAUGHTY>;
	close (NAUGHTY);
	print "<CENTER>\n",
	  "<P><BIG><BIG><STRONG>$text{'0026'}</STRONG></BIG></BIG>\n",
	  "</CENTER>\n<P>$text{'0030'}\n<CENTER>\n",
	  "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
	  "naughtyeditfinal\"$BBStarget>",
	  "<P><FONT FACE=\"Courier\"><TEXTAREA COLS=$InputColumns ROWS=$InputRows ",
	  "NAME=\"listitems\" WRAP=VIRTUAL>";
	foreach $naughtyword (@naughtywords) { print "$naughtyword"; }
	print "</TEXTAREA></FONT>\n";
	unless ($BypassPassword) {	
		print "<P>$text{'0206'}: <FONT FACE=\"Courier\">",
		  "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
		if ($FORM{'newpassword'}) {
			print "VALUE=\"$FORM{'newpassword'}\" ";
		}
		print "SIZE=15></FONT>";
	}
	print "<P><INPUT TYPE=SUBMIT VALUE=\"$text{'0028'}\"> ";
	print "</FORM></CENTER>\n";
	&Footer($MessageFooterFile,"credits");
}

sub AddressEditFinal {
	unless ($BypassPassword) { &AdminPasswordCheck; }
	&LockOpen (ADDRESSES,"$dir/addresses.txt");
	foreach $item (@listitems) { print ADDRESSES "$item\n"; }
	truncate (ADDRESSES, tell(ADDRESSES));
	&LockClose (ADDRESSES,"$dir/addresses.txt");
	&Header($text{'0029'},$MessageHeaderFile);
	&Header2;
	open (ADDRESSES,"$dir/addresses.txt");
	@addresses = <ADDRESSES>;
	close (ADDRESSES);
	print "<CENTER><P><BIG><BIG><STRONG>$text{'0029'}";
	print "</STRONG></BIG></BIG></CENTER>\n";
	foreach $address (@addresses) { print "<BR>$address"; }
	&Footer($MessageFooterFile,"credits");
}

sub BannedEditFinal {
	unless ($BypassPassword) { &AdminPasswordCheck; }
	&LockOpen (BANNED,"$BannedIPsFile");
	foreach $item (@listitems) { print BANNED "$item\n"; }
	truncate (BANNED, tell(BANNED));
	&LockClose (BANNED,"$BannedIPsFile");
	&Header($text{'0027'},$MessageHeaderFile);
	&Header2;
	open (BANNED,"$BannedIPsFile");
	@bannedips = <BANNED>;
	close (BANNED);
	print "<CENTER><P><BIG><BIG><STRONG>$text{'0027'}";
	print "</STRONG></BIG></BIG></CENTER>\n";
	foreach $bannedip (@bannedips) { print "<BR>$bannedip"; }
	&Footer($MessageFooterFile,"credits");
}

sub NaughtyEditFinal {
	unless ($BypassPassword) { &AdminPasswordCheck; }
	&LockOpen (NAUGHTY,"$NaughtyWordsFile");
	foreach $item (@listitems) { print NAUGHTY "$item\n"; }
	truncate (NAUGHTY, tell(NAUGHTY));
	&LockClose (NAUGHTY,"$NaughtyWordsFile");
	&Header($text{'0026'},$MessageHeaderFile);
	&Header2;
	open (NAUGHTY,"$NaughtyWordsFile");
	@naughtywords = <NAUGHTY>;
	close (NAUGHTY);
	print "<CENTER><P><BIG><BIG><STRONG>$text{'0026'}";
	print "</STRONG></BIG></BIG></CENTER>\n";
	foreach $naughtyword (@naughtywords) { print "<BR>$naughtyword"; }
	&Footer($MessageFooterFile,"credits");
}

sub DisplayMessageAdmin {
	print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
	  "delete\"$BBStarget>",
	  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"DeleteConfirm\" ",
	  "VALUE=\"Yes\">",
	  "<INPUT TYPE=HIDDEN NAME=\"delete\" ",
	  "VALUE=\"$messagenumber\">",
	  "<INPUT TYPE=SUBMIT VALUE=\"$text{'0201'}\"> ";
	unless ($BypassPassword) {	
		print "$text{'0206'}: </FONT><FONT FACE=\"Courier\">",
		  "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
		if ($FORM{'newpassword'}) {
			print "VALUE=\"$FORM{'newpassword'}\" ";
		}
		print "SIZE=15>";
	}
	print "$NavBarEnd</FORM>\n";
	$FormCount++;
	if ($ArchiveDir) {
		print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
		  "delete\"$BBStarget>",
		  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"DeleteConfirm\" ",
		  "VALUE=\"Yes\">",
		  "<INPUT TYPE=HIDDEN NAME=\"delete\" ",
		  "VALUE=\"$messagenumber\">",
		  "<INPUT TYPE=SUBMIT NAME=\"archive\" VALUE=\"$text{'0301'}\"> ";
		unless ($BypassPassword) {	
			print "$text{'0206'}: </FONT><FONT FACE=\"Courier\">",
			  "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
			if ($FORM{'newpassword'}) {
				print "VALUE=\"$FORM{'newpassword'}\" ";
			}
			print "SIZE=15>";
		}
		print "$NavBarEnd</FORM>\n";
		$FormCount++;
	}
	unless (($previous == 0) && ($next == 0)) {
		$DeleteSelect = 1;
		$ToBeDeleted = "";
		print "<P ALIGN=CENTER><BIG><STRONG>";
		print "<A NAME=\"Responses\">";
		@responses = split(/ /,$next);
		$responsecount = 0;
		print "$text{'1005'}</A></STRONG></BIG>\n";
		print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
		  "delete\"$BBStarget>\n";
		print "<P><$ul_dl>";
		&FindStart($messagenumber);
		&ThreadList($threadstart);
		print "</$ul_dl>\n";
		print "$NavBarStart",
		  "<INPUT TYPE=SUBMIT VALUE=\"$text{'0202'}\"> ";
		unless ($BypassPassword) {	
			print "$text{'0206'}: </FONT>",
			  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpasswordD\" ";
			if ($FORM{'newpassword'}) {
				print "VALUE=\"$FORM{'newpassword'}\" ";
			}
			print "SIZE=15>";
		}
		print "$NavBarEnd";
		if ($ArchiveDir) {
			print "$NavBarStart",
			  "<INPUT TYPE=SUBMIT NAME=\"archive\" VALUE=\"$text{'0302'}\"> ";
			unless ($BypassPassword) {	
				print "$text{'0206'}: </FONT>",
				  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpasswordA\" ";
				if ($FORM{'newpassword'}) {
					print "VALUE=\"$FORM{'newpassword'}\" ";
				}
				print "SIZE=15>";
			}
			print "$NavBarEnd";
		}
		print "</FORM>\n";
		$FormCount++;
		print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
		  "delete\"$BBStarget>",
		  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"delete\" ",
		  "VALUE=\"$ToBeDeleted\">",
		  "<INPUT TYPE=SUBMIT VALUE=\"$text{'0204'}\"> ";
		unless ($BypassPassword) {	
			print "$text{'0206'}: </FONT>",
			  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
			if ($FORM{'newpassword'}) {
				print "VALUE=\"$FORM{'newpassword'}\" ";
			}
			print "SIZE=15>";
		}
		print "$NavBarEnd</FORM>\n";
		$FormCount++;
		if ($ArchiveDir) {
			print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
			  "delete\"$BBStarget>",
			  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"delete\" ",
			  "VALUE=\"$ToBeDeleted\">",
			  "<INPUT TYPE=SUBMIT NAME=\"archive\" VALUE=\"$text{'0304'}\"> ";
			unless ($BypassPassword) {	
				print "$text{'0206'}: </FONT>",
				  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
				if ($FORM{'newpassword'}) {
					print "VALUE=\"$FORM{'newpassword'}\" ";
				}
				print "SIZE=15>";
			}
			print "$NavBarEnd</FORM>\n";
			$FormCount++;
		}
	}
}

sub AdminDelete {
	unless ($BypassPassword) {	
		if ($FORM{'newpasswordD'}) { $FORM{'newpassword'} = $FORM{'newpasswordD'}; }
		if ($FORM{'newpasswordA'}) { $FORM{'newpassword'} = $FORM{'newpasswordA'}; }
		&AdminPasswordCheck;
		unless ($FORM{'delete'}) {
			&Error("9600","9601");
		}
	}
	@messages = split(/\s+/,$FORM{'delete'});
	if ($ArchiveDir && $FORM{'archive'}) { &Archive; }
	unless ($FORM{'DeleteConfirm'}) {
		&Header($text{'0209'},$MessageHeaderFile);
		&Header2;
		print "<P>$text{'0210'}\n";
		print "<P><$ul_dl>\n";
		@sortedmessages = sort {$a<=>$b} @messages;
		foreach $message (@sortedmessages) {
			&PrintMessageDesc($message);
		}
		print "</$ul_dl>\n";
		print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
		  "delete\"$BBStarget>\n",
		  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"DeleteConfirm\" ",
		  "VALUE=\"Yes\">\n",
		  "<INPUT TYPE=HIDDEN NAME=\"delete\" ",
		  "VALUE=\"$FORM{'delete'}\">\n",
		  "<INPUT TYPE=SUBMIT VALUE=\"$text{'0211'}\"> ";
		unless ($BypassPassword) {	
			print "$text{'0206'}: </FONT>",
			  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
			if ($FORM{'newpassword'}) {
				print "VALUE=\"$FORM{'newpassword'}\" ";
			}
			print "SIZE=15>";
		}
		print "$NavBarEnd</FORM>\n";
		&Footer($MessageFooterFile,"return");
	}
	foreach $message (@messages) {
		$subdir = "bbs".int(int($message)/1000);
		unlink "$dir/$subdir/$message";
		delete ($MessageList{$message});
		if ($CountList{$message}) { delete ($CountList{$message}); }
	}
	unless ($FORM{'delete'} =~ /tmp/) {
		open (SEARCH,"$dir/searchterms.idx");
		&LockOpen (NEWSEARCH,"$dir/newsearchterms.idx");
		while (<SEARCH>) {
			if (/^(\d+) /) {
				$message = $1;
				$subdir = "bbs".int($message/1000);
				if (-e "$dir/$subdir/$message") {
					print NEWSEARCH "$_";
				}
			}
		}
		close (SEARCH);
		&LockOpen (SEARCH,"$dir/searchterms.idx");
		rename ("$dir/newsearchterms.idx","$dir/searchterms.idx");
		&LockClose (NEWSEARCH,"$dir/newsearchterms.idx");
		&LockClose (SEARCH,"$dir/searchterms.idx");
	}
	&Header($text{'0212'},$MessageHeaderFile,"refresh");
	&Header2("refresh");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>$text{'0212'}</STRONG></BIG></BIG>\n";
	print "<P ALIGN=CENTER>$text{'0200'}\n";
	&Footer($MessageFooterFile,"return","refresh");
}

sub Archive {
	unless ($FORM{'DeleteConfirm'}) {
		&Header($text{'0309'},$MessageHeaderFile);
		&Header2;
		print "<P>$text{'0310'}\n";
		print "<P><$ul_dl>\n";
		@sortedmessages = sort {$a<=>$b} @messages;
		foreach $message (@sortedmessages) {
			&PrintMessageDesc($message);
		}
		print "</$ul_dl>\n";
		print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
		  "delete\"$BBStarget>\n",
		  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"DeleteConfirm\" ",
		  "VALUE=\"Yes\">\n",
		  "<INPUT TYPE=HIDDEN NAME=\"delete\" ",
		  "VALUE=\"$FORM{'delete'}\">\n",
		  "<INPUT TYPE=SUBMIT NAME=\"archive\" VALUE=\"$text{'0311'}\"> ";
		unless ($BypassPassword) {	
			print "$text{'0206'}: </FONT>",
			  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
			if ($FORM{'newpassword'}) {
				print "VALUE=\"$FORM{'newpassword'}\" ";
			}
			print "SIZE=15>";
		}
		print "$NavBarEnd</FORM>\n";
		&Footer($MessageFooterFile,"return");
	}
	&LockOpen (DBLOCK,"$ArchiveDir/dblock.txt");
	if ($DBMType==1) {
		tie (%ArcMessageList,'AnyDBM_File',"$ArchiveDir/messagelist",O_RDWR|O_CREAT,0666,$DB_HASH)
		  || print "(Error!) ";
	}
	elsif ($DBMType==2) {
		dbmopen(%ArcMessageList,"$ArchiveDir/messagelist",0666)
		  || print "(Error!) ";
	}
	else {
		tie (%ArcMessageList,'AnyDBM_File',"$ArchiveDir/messagelist",O_RDWR|O_CREAT,0666)
		  || print "(Error!) ";
	}
	&LockOpen (COUNTLOCK,"$ArchiveDir/countlock.txt");
	if ($DBMType==1) {
		tie (%ArcCountList,'AnyDBM_File',"$ArchiveDir/countlist",O_RDWR|O_CREAT,0666,$DB_HASH)
		  || print "(Error!) ";
	}
	elsif ($DBMType==2) {
		dbmopen(%ArcCountList,"$ArchiveDir/countlist",0666)
		  || print "(Error!) ";
	}
	else {
		tie (%ArcCountList,'AnyDBM_File',"$ArchiveDir/countlist",O_RDWR|O_CREAT,0666)
		  || print "(Error!) ";
	}
	%ToMove = ();
	foreach $message (@messages) {
		$subdir = "bbs".int(int($message)/1000);
		$ToMove{$message} = 1;
		unless (-d "$ArchiveDir/$subdir") {
			mkdir ("$ArchiveDir/$subdir",0777);
			chmod 0777,"$ArchiveDir/$subdir";
		}
		rename ("$dir/$subdir/$message","$ArchiveDir/$subdir/$message");
		$ArcMessageList{$message} = $MessageList{$message};
		$ArcCountList{$message} = $CountList{$message};
		delete ($MessageList{$message});
		delete ($CountList{$message});
	}
	unless ($FORM{'delete'} =~ /tmp/) {
		open (SEARCH,"$dir/searchterms.idx");
		&LockOpen (NEWSEARCH,"$dir/newsearchterms.idx");
		&LockOpen (ARCSEARCH,"$ArchiveDir/searchterms.idx","a");
		while (<SEARCH>) {
			if (/^(\d+) /) {
				$message = $1;
				if ($ToMove{$1}) {
					print ARCSEARCH "$_";
				}
				else {
					$subdir = "bbs".int($message/1000);
					if (-e "$dir/$subdir/$message") {
						print NEWSEARCH "$_";
					}
				}
			}
		}
		&LockClose (ARCSEARCH,"$ArchiveDir/searchterms.idx");
		close (SEARCH);
		&LockOpen (SEARCH,"$dir/searchterms.idx");
		rename ("$dir/newsearchterms.idx","$dir/searchterms.idx");
		&LockClose (NEWSEARCH,"$dir/newsearchterms.idx");
		&LockClose (SEARCH,"$dir/searchterms.idx");
	}
	if ($DBMType==2) { dbmclose (%ArcMessageList); }
	else { untie %ArcMessageList; }
	&LockClose (DBLOCK,"$ArchiveDir/dblock.txt");
	if ($DBMType==2) { dbmclose (%ArcCountList); }
	else { untie %ArcCountList; }
	&LockClose (DBLOCK,"$ArchiveDir/countlock.txt");
	&Header($text{'0312'},$MessageHeaderFile,"refresh");
	&Header2("refresh");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>$text{'0312'}</STRONG></BIG></BIG>\n";
	print "<P ALIGN=CENTER>$text{'0300'}\n";
	&Footer($MessageFooterFile,"return","refresh");
}

sub ResetPassword {
	if (($FORM{'oldpassword'} eq "NoPasswordYet")
	  && (-e "$dir/password.txt")) {
		&Error("9600","9601");
	}
	elsif (-e "$dir/password.txt") {
		$oldpassword = crypt($FORM{'oldpassword'},"aa");
		open (PASSWORD, "$dir/password.txt");
		$password = <PASSWORD>;
		close (PASSWORD);
		chop ($password) if ($password =~ /\n$/);
		unless ($oldpassword eq $password) { &Error("9600","9601"); }
	}
	unless ($FORM{'passad'} && ($FORM{'passad'} eq $FORM{'passad2'})) {
		&Error("9602","9603");
	}
	$newpassword = crypt($FORM{'passad'},"aa");
	open (PASSWORD, ">$dir/password.txt");
	print PASSWORD "$newpassword";
	close (PASSWORD);
	&Header($text{'0213'},$MessageHeaderFile,"refresh");
	&Header2("refresh");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>$text{'0213'}</STRONG></BIG></BIG>\n";
	print "<P ALIGN=CENTER>$text{'0214'}\n";
	&Footer($MessageFooterFile,"return","refresh");
}

sub PostEditForm {
	$SpellCheckerMeta = 1;
	&Header($text{'1504'},$MessageHeaderFile);
	$navbar = $NavBarStart." <A HREF=\"$adminurl$BBSquery\" $BBStargettop>";
	$navbar .= "$text{'0004'}</A>";
	$navbar .= $NavBarEnd;
	print "$navbar";
	if ($printboardname) {
		print "<P ALIGN=CENTER><BIG><STRONG>";
		print "$boardname</STRONG></BIG>\n";
	}
	$subdir = "bbs".int($messagenumber/1000);
	open (FILE,"$dir/$subdir/$messagenumber");
	@message = <FILE>;
	close (FILE);
	&Print_EditForm($messagenumber);
	print "<P>&nbsp;";
	&Footer($MessageFooterFile,"credits");
}

sub Print_AdminForm {
	print "<TH COLSPAN=2>$TableCellStart";
	print "$text{'1518'} ";
	print "<INPUT TYPE=RADIO NAME=\"Admin\" ";
	print "VALUE=\"AdminPost\"";
	if (($_[0] > -1) || ($FORM{'Admin'} eq "AdminPost")) {
		print " CHECKED";
	}
	print "> $text{'1519'}";
	print "<INPUT TYPE=RADIO NAME=\"Admin\" ";
	print "VALUE=\"No\"";
	if (($_[0] == -1) && ($FORM{'Admin'} ne "AdminPost")) {
		print " CHECKED";
	}
	print "> $text{'1520'}";
	print "</FONT></TH></TR><TR>\n";
	unless ($BypassPassword) {	
		print "<TH COLSPAN=2>$TableCellStart";
		print "<EM>$text{'0206'}:</EM> </FONT><FONT FACE=\"Courier\">";
		print "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
		if ($FORM{'newpassword'}) {
			print "VALUE=\"$FORM{'newpassword'}\" ";
		}
		print "SIZE=15></FONT></TH></TR><TR>\n";
	}
}

sub Print_EditForm {
	$quotedtext = "";
	foreach $line (@message) {
		if ($line =~ /^SUBJECT>(.*)/i) { $sub=$1; }
		elsif ($line =~ /^ADMIN>(.*)/i) { $admin=$1; }
		elsif ($line =~ /^POSTER>(.*)/i) { $poster=$1; }
		elsif ($line =~ /^EMAIL>(.*)/i) { $email=$1; }
		elsif ($line =~ /^DATE>(.*)/i) { $date=$1; }
		elsif ($line =~ /^EMAILNOTICES>(.*)/i) { $wantemail=$1; }
		elsif ($line =~ /^IP_ADDRESS>(.*)/i) { $ip=$1; }
		elsif ($line =~ /^<!--/i) { next; }
		elsif ($line =~ /^PASSWORD>(.*)/i) { $password=$1; }
		elsif ($line =~ /^PREVIOUS>(.*)/i) { $prev=$1; }
		elsif ($line =~ /^NEXT>(.*)/i) { $next=$1; }
		elsif ($line =~ /^IMAGE>(.*)/i) { $imageurl=$1; }
		elsif ($line =~ /^LINKNAME>(.*)/i) { $linkname=$1; }
		elsif ($line =~ /^LINKURL>(.*)/i) { $linkurl=$1;}
		else { $quotedtext .= $line; }
	}
	if (%SmileyCode) {
		foreach $key (keys %SmileyCode) {
			$key2 = $SmileyCode{$key};
			$key2 =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
			$quotedtext =~ s/$key2/$key/g;
		}
	}
	if (%FormatCode) {
		foreach $key (keys %FormatCode) {
			$key2 = $FormatCode{$key};
			$key2 =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
			$quotedtext =~ s/$key2/$key/ig;
		}
	}
	$quotedtext =~ s/\n//g;
	$quotedtext =~ s/<P>/\n\n/g;
	$quotedtext =~ s/<BR>/\n/g;
	$quotedtext =~ s/^\n*//g;
	$quotedtext =~ s/\n*$//g;
	$quotedtext =~ s/\& /\&amp\; /g;
	$quotedtext =~ s/"/\&quot\;/g;
	$quotedtext =~ s/</\&lt\;/g;
	$quotedtext =~ s/>/\&gt\;/g;
	print "<P><FORM METHOD=POST ACTION=\"$adminurl$BBSquery";
	print "post\" TARGET=\"_self\">\n";
	print "<INPUT TYPE=HIDDEN NAME=\"EditPost\" ";
	print "VALUE=\"$_[0]\">\n";
	print "<P>&nbsp;";
	print "<P><CENTER><TABLE $tablespec><TR>\n";
	print "<TH COLSPAN=2>$TableCellStart<BIG>";
	print "$text{'1504'} # $_[0]\n";
	print "</BIG></FONT></TH></TR><TR><TD COLSPAN=2>$TableCellStart";
	print "<HR WIDTH=75% NOSHADE></FONT></TR><TR>\n";
	print "<TH ALIGN=RIGHT>$TableCellStart";
	print "$text{'1510'}:";
	print "</FONT></TH><TD>$TableInputCellStart<INPUT TYPE=TEXT NAME=\"name\" ";
	print "SIZE=$InputLength";
	print " VALUE=\"$poster\"";
	print "></FONT></TD></TR><TR>\n";
	print "<TH ALIGN=RIGHT>$TableCellStart";
	print "$text{'1511'}:";
	print "</FONT></TH><TD>$TableInputCellStart<INPUT TYPE=TEXT NAME=\"email\" ";
	print "SIZE=$InputLength MAXLENGTH=100";
	print " VALUE=\"$email\"";
	print "></FONT></TD></TR><TR>\n";
	print "<TH ALIGN=RIGHT>$TableCellStart";
	print "$text{'1512'}:";
	print "</FONT></TH><TD>$TableInputCellStart<INPUT TYPE=TEXT NAME=\"subject\" ";
	print "SIZE=$InputLength";
	if (%SmileyCode) {
		foreach $key (keys %SmileyCode) {
			$key2 = $SmileyCode{$key};
			$key2 =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
			$sub =~ s/$key2/$key/g;
		}
	}
	if ($NM_Telltale) {
		$NM_Telltale =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
		$sub =~ s/ $NM_Telltale//g;
	}
	if ($Pic_Telltale) {
		$Pic_Telltale =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
		$sub =~ s/ $Pic_Telltale//g;
	}
	$sub =~ s/"/&quot;/g;
	print " VALUE=\"$sub\"";
	print "></FONT></TD></TR><TR>\n";
	print "<TD COLSPAN=2 ALIGN=CENTER>$TableCellStart";
	print "<STRONG>$text{'1514'}:</STRONG></FONT>\n";
	print "<BR><FONT FACE=\"Courier\"><TEXTAREA COLS=$InputColumns ROWS=$InputRows ";
	print "NAME=\"body\" WRAP=VIRTUAL>";
	print "$quotedtext";
	print "</TEXTAREA></FONT></TD></TR><TR>\n";
	print "<TH ALIGN=RIGHT>$TableCellStart";
	print "$text{'1515'}:</FONT></TH>";
	print "<TD>$TableInputCellStart<INPUT TYPE=TEXT ";
	print "NAME=\"url\" SIZE=$InputLength MAXLENGTH=250";
	print " VALUE=\"$linkurl\"";
	print "></FONT></TD></TR><TR>\n";
	print "<TH ALIGN=RIGHT>$TableCellStart";
	print "$text{'1516'}:</FONT></TH>";
	print "<TD>$TableInputCellStart<INPUT TYPE=TEXT ";
	print "NAME=\"url_title\" SIZE=$InputLength";
	print " VALUE=\"$linkname\"";
	print "></FONT></TD></TR><TR>\n";
	print "<TH ALIGN=RIGHT>$TableCellStart";
	print "$text{'1517'}:</FONT></TH>";
	print "<TD>$TableInputCellStart<INPUT TYPE=TEXT ";
	print "NAME=\"imageurl\" SIZE=$InputLength MAXLENGTH=250";
	print " VALUE=\"$imageurl\"";
	print "></FONT></TD></TR><TR>\n";
	print "<TH COLSPAN=2>$TableCellStart";
	print "$text{'1560'}: </FONT><FONT FACE=\"Courier\">";
	print "<INPUT TYPE=TEXT NAME=\"NewParent\" SIZE=10";
	if ($prev) { print " VALUE=\"$prev\""; }
	print "></FONT></TH></TR><TR>\n";
	print "<TH COLSPAN=2>$TableCellStart";
	print "$text{'1518'} ";
	print "<INPUT TYPE=RADIO NAME=\"Admin\" ";
	print "VALUE=\"AdminPost\"";
	if ($admin eq "AdminPost") { print " CHECKED"; }
	print "> $text{'1519'}";
	print "<INPUT TYPE=RADIO NAME=\"Admin\" ";
	print "VALUE=\"No\"";
	unless ($admin eq "AdminPost") { print " CHECKED"; }
	print "> $text{'1520'}";
	print "</FONT></TH></TR><TR>\n";
	unless ($BypassPassword) {	
		print "<TH COLSPAN=2>$TableCellStart";
		print "<EM>$text{'0206'}:</EM> </FONT><FONT FACE=\"Courier\">";
		print "<INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
		if ($FORM{'newpassword'}) {
			print "VALUE=\"$FORM{'newpassword'}\" ";
		}
		print "SIZE=15></FONT></TH></TR><TR>\n";
	}
	print "<TD COLSPAN=2>$TableCellStart";
	print "<HR WIDTH=75% NOSHADE></FONT></TD></TR><TR>\n";
	print "<TD COLSPAN=2 ALIGN=CENTER>$TableCellStart";
	if ($SpellCheckerID && $SpellCheckerPath) {
		print "<INPUT TYPE=BUTTON VALUE=\"$text{'1552'}\" ";
		print "onclick=\"var f = document.forms[$FormCount]; ";
		print "doSpell( '$SpellCheckerLang', f.body, ";
		print "document.location.protocol + '//' + ";
		print "document.location.host + '$SpellCheckerPath', true);\">"; 
		print "&nbsp;"; 
	}
	print "<INPUT TYPE=SUBMIT NAME=\"Post\" ";
	print "VALUE=\"$text{'1504'}\"></FONT></TD>";
	print "</TR></TABLE></CENTER>";
	print "</FORM>\n";
	$FormCount++;
}

sub Moderate {
	&Header($text{'0700'},$HeaderFile);
	$navbar = $NavBarStart;
	$navbar .= " <A HREF=\"$adminurl$BBSquery\"";
	if ($UseFrames) { $navbar .= "$BBStargettop>"; }
	else { $navbar .= ">"; }
	$navbar .= "$text{'0004'}</A>";
	$navbar .= $NavBarEnd;
	print "$navbar";
	if ($printboardname) {
		print "<P ALIGN=CENTER><BIG><STRONG>";
		print "$boardname</STRONG></BIG>\n";
	}
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>$text{'0700'}</STRONG></BIG></BIG>\n";
	@moderate = ();
	opendir (MESSAGES,$dir);
	@messagedir = readdir(MESSAGES);
	closedir (MESSAGES);
	foreach $message (@messagedir) {
		next if ($message =~ /^\./);
		if ((-d "$dir/$message")
		  && ($message =~ /^bbs\d+/)) {
			opendir (COUNT,"$dir/$message");
			push (@messagecount,readdir(COUNT));
			closedir (COUNT);
		}
		else {
			push (@messagecount,"$message");
		}
	}
	foreach $message (@messagecount) {
		if (($message =~ /\.tmp$/) && (int($message) > 0)) {
			push (@moderate,$message);
		}
	}
	@sortedmessages = (sort {$b<=>$a} @moderate);
	$MessageCount = @sortedmessages;
	if ($MessageCount > 0) {
		print "<P><$ul_dl>\n";
		foreach $message (@sortedmessages) {
			$subdir = "bbs".int(int($message)/1000);
			open (FILE,"$dir/$subdir/$message");
			@message = <FILE>;
			close (FILE);
			$subject=$poster=$date=$ipaddress="";
			foreach $line (@message) {
				if ($line =~ /^SUBJECT>(.*)/i) { $subject = $1; }
				elsif ($line =~ /^POSTER>(.*)/i) { $poster = $1; }
				elsif ($line =~ /^DATE>(.*)/i) { $date = $1; }
				elsif ($line =~ /^IP_ADDRESS>(.*)/i) { $ipaddress = $1; last; }
				else { next; }
			}
			unless ($subject) {
				unlink ("$dir/$subdir/$message");
				unlink ("$dir/$message");
				next;
			}
			print "<$li_dd><STRONG>";
			print "<A HREF=\"$adminurl$BBSquery";
			print "moderate=$message\"$BBStarget>";
			print "$subject</A></STRONG>";
			if ($IndexEntryLines == 1) { print " -- "; }
			else { print "<BR>"; }
			print "$poster ";
			if ($DisplayIPs && $ipaddress) {
				print " <SMALL><EM>($ipaddress)</EM></SMALL> ";
			}
			print "-- ",&PrintDate($date);
			print "\n";
		}
		print "</$ul_dl>\n";
	}
	else {
		print "<P ALIGN=CENTER><STRONG>$text{'0701'}</STRONG>\n";
	}
	&Footer($FooterFile,"credits");
}

sub DisplayIndexAdmin1 {
	$navbar .= " <A HREF=\"$adminurl$BBSquery";
	$navbar .= "moderate=0\"$BBStargettop>$text{'0025'}</A> |";
	if ($SepPostFormIndex) {
		$navbar .= " <A HREF=\"$adminurl$BBSquery";
		$navbar .= "form=0\"";
		$navbar .= "$BBStargettop>";
	}
	else {
		$navbar .= " <A HREF=\"#PostMessage\">";
	}
	$navbar .= "$text{'0007'}</A>";
	if ($mailprog && $email_list) {
		$navbar .= " | <A HREF=\"$adminurl$BBSquery";
		$navbar .= "subscribe\"$BBStarget> $text{'0008'}</A>";
	}
	unless ($FORM{'KeySearch'}) {
		$FORM{'KeySearch'} = "No";
	}
	if ($FORM{'KeySearch'} ne "No") {
		$navbar .= " | <A HREF=\"$adminurl$BBSquery\" ";
		$navbar .= "$BBStargettop>";
		$navbar .= "$text{'0004'}</A>";
	}
	$navbar .= " | <A HREF=\"$adminurl$BBSquery";
	$navbar .= "search\"$BBStarget>$text{'0009'}</A>";
	$navbar .= " | <A HREF=\"$adminurl$BBSquery";
	$navbar .= "reconfigure\"$BBStarget>$text{'0010'}</A>";
	$navbar .= " | <A HREF=\"$adminurl$BBSquery";
	$navbar .= "topstats\"$BBStarget>$text{'0502'}</A>";
	if ($mailprog && $email_list) {
			$navbar .= " | ";
			$navbar .= "<A HREF=\"$adminurl$BBSquery";
			$navbar .= "addressedit\"$BBStarget>$text{'0029'}</A>";
	}
	if ($NaughtyWordsFile) {
			$navbar .= " | ";
			$navbar .= "<A HREF=\"$adminurl$BBSquery";
			$navbar .= "naughtyedit\"$BBStarget>$text{'0026'}</A>";
	}
	if ($BannedIPsFile) {
			$navbar .= " | ";
			$navbar .= "<A HREF=\"$adminurl$BBSquery";
			$navbar .= "bannededit\"$BBStarget>$text{'0027'}</A>";
	}
	if (%Navbar_Links) {
		foreach $key (keys %Navbar_Links) {
			$navbar .= " | ";
			($NavLinkURL,$NavLinkTarget) = split(/\|/,$Navbar_Links{$key});
			$navbar .= "<A HREF=\"$NavLinkURL\"";
			if ($NavLinkTarget) { $navbar .= " TARGET=\"$NavLinkTarget\""; }
			else { $navbar .= " $BBStarget"; }
			$navbar .= ">$key</A>";
		}
	}
}

sub DisplayIndexAdmin2 {
	print "$NavBarStart<A HREF=\"$adminurl$BBSquery",
	  "checkdb\"$BBStarget>$text{'8000'}</A> | ",
	  "<A HREF=\"$adminurl$BBSquery",
	  "rebuild\"$BBStargettop>$text{'8001'}</A>$NavBarEnd\n";
	unless ($BypassPassword) {	
		print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
		  "resetpass\"$BBStarget>$NavBarStart<CENTER>\n";
		unless (-e "$dir/password.txt") {
			print "<INPUT TYPE=HIDDEN NAME=oldpassword ";
			print "VALUE=NoPasswordYet>";
		}
		else {
			print "$text{'0207'}: <FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD ";
			print "NAME=oldpassword SIZE=10></FONT><BR>";
		}
		print "$text{'0208'}: ",
		  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=passad SIZE=10> ",
		  "<INPUT TYPE=PASSWORD NAME=passad2 SIZE=10></FONT>",
		  "</CENTER></SMALL></FONT></TD></TR>\n",
		  "<TR><TD NOWRAP><FONT ".$navbarfontspec."><SMALL><CENTER>",
		  "<INPUT TYPE=SUBMIT ",
		  "VALUE=\"$text{'0215'}\"></CENTER>$NavBarEnd</FORM>\n";
		$FormCount++;
	}
}

sub DisplayIndexAdmin3 {
	$SearchString = "$text{'0520'} ";
	$SearchString .= "<STRONG>&quot;$FORM{'Domain'}&quot;</STRONG>";
	foreach $message (@sortedmessages) {
		if ((int($MessageList{$message}) >= $startday) && (int($MessageList{$message}) <= $endday)) {
			$date=$sub=$poster=$prev=$next=$count=$admin=$ip="";
			($date,$sub,$poster,$prev,$next,$count,$admin,$ip) =
			  split(/\|/,$MessageList{$message});
			if ($ip =~ /$FORM{'Domain'}/i) {
				push (@keywordmatches, $message);
			}
			else {
				$DontUse{$message} = 1;
			}
		}
		else {
			$DontUse{$message} = 1;
		}
	}
	@sortedmessages = (sort {$a<=>$b} @keywordmatches);
}

sub DisplayIndexAdmin4 {
	if ($messagecount < 1) {
		print "</FORM>\n";
		$FormCount++;
		print "<P ALIGN=CENTER><STRONG>$text{'0524'}</STRONG>\n";
	}
	else {
		print "$NavBarStart",
		  "<INPUT TYPE=SUBMIT VALUE=\"$text{'0202'}\"> ";
		unless ($BypassPassword) {	
			print "$text{'0206'}: </FONT>",
			  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpasswordD\" ";
			if ($FORM{'newpassword'}) {
				print "VALUE=\"$FORM{'newpassword'}\" ";
			}
			print "SIZE=15>";
		}
		print "$NavBarEnd";
		if ($ArchiveDir) {
			print "$NavBarStart",
			  "<INPUT TYPE=SUBMIT NAME=\"archive\" VALUE=\"$text{'0302'}\"> ";
			unless ($BypassPassword) {	
				print "$text{'0206'}: </FONT>",
				  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpasswordA\" ";
				if ($FORM{'newpassword'}) {
					print "VALUE=\"$FORM{'newpassword'}\" ";
				}
				print "SIZE=15>";
			}
			print "$NavBarEnd";
		}
		print "</FORM>\n";
		$FormCount++;
		print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
		  "delete\"$BBStarget>\n",
		  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"delete\" ",
		  "VALUE=\"$ToBeDeleted\">\n",
		  "<INPUT TYPE=SUBMIT VALUE=\"$text{'0203'}\"> ";
		unless ($BypassPassword) {	
			print "$text{'0206'}: </FONT>",
			  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
			if ($FORM{'newpassword'}) {
				print "VALUE=\"$FORM{'newpassword'}\" ";
			}
			print "SIZE=15>";
		}
		print "$NavBarEnd</FORM>\n";
		$FormCount++;
		if ($ArchiveDir) {
			print "<FORM METHOD=POST ACTION=\"$adminurl$BBSquery",
			  "delete\"$BBStarget>\n",
			  "$NavBarStart<INPUT TYPE=HIDDEN NAME=\"delete\" ",
			  "VALUE=\"$ToBeDeleted\">\n",
			  "<INPUT TYPE=SUBMIT NAME=\"archive\" VALUE=\"$text{'0303'}\"> ";
			unless ($BypassPassword) {	
				print "$text{'0206'}: </FONT>",
				  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=\"newpassword\" ";
				if ($FORM{'newpassword'}) {
					print "VALUE=\"$FORM{'newpassword'}\" ";
				}
				print "SIZE=15>";
			}
			print "$NavBarEnd</FORM>\n";
			$FormCount++;
		}
	}
}

sub AdminPasswordCheck {
	unless ($FORM{'newpassword'}) { &Error("9600","9601"); }
	$newpassword = crypt($FORM{'newpassword'},"aa");
	unless (-e "$dir/password.txt") {
		&Error("9600","9601");
	}
	open (PASSWORD, "$dir/password.txt");
	$password = <PASSWORD>;
	close (PASSWORD);
	chop ($password) if ($password =~ /\n$/);
	unless ($newpassword eq $password) {
		&Error("9600","9601");
	}
}

sub PostAdminMessage {
	unless ($BypassPassword) { &AdminPasswordCheck; }
	if ($FORM{'ApprovePost'}) {
		$num = int($FORM{'ApprovePost'});
		$subdir = "bbs".int($num/1000);
		rename ("$dir/$subdir/$FORM{'ApprovePost'}","$dir/$subdir/$num");
		open (FILE,"$dir/$subdir/$num") || &Error("9100","9101");
		@message = <FILE>;
		close (FILE);
		$email=$followup=$message_url_title=$message_url="";
		foreach $line (@message) {
			if ($line =~ /^SUBJECT>(.*)/i) { $subject = $1; }
			elsif ($line =~ /^ADMIN>/i) { next; }
			elsif ($line =~ /^POSTER>(.*)/i) { $name = $1; }
			elsif ($line =~ /^EMAIL>(.*)/i) { $email = $1; }
			elsif ($line =~ /^DATE>(.*)/i) { $todaydate = $1; }
			elsif ($line =~ /^EMAILNOTICES>/i) { next; }
			elsif ($line =~ /^IP_ADDRESS>(.*)/i) { $ENV{'REMOTE_HOST'} = $1; }
			elsif ($line =~ /^<!--/i) { next; }
			elsif ($line =~ /^PASSWORD>/i) { next; }
			elsif ($line =~ /^PREVIOUS>(.*)/i) { $followup = $1; }
			elsif ($line =~ /^NEXT>/i) { next; }
			elsif ($line =~ /^IMAGE>(.*)/i) { next; }
			elsif ($line =~ /^LINKNAME>(.*)/i) { $message_url_title = $1; }
			elsif ($line =~ /^LINKURL>(.*)/i) { $message_url = $1; }
			else { $body .= $line; }
		}
		$FORM{'subject'} = $subject;
		$FORM{'name'} = $name;
		$FORM{'body'} = $body;
	}
	else {
		if ($ResolveIPs) {
			if (($ENV{'REMOTE_ADDR'} =~ /\d+\.\d+\.\d+\.\d+/)
			  && (!($ENV{'REMOTE_HOST'})
			  || ($ENV{'REMOTE_HOST'} =~ /\d+\.\d+\.\d+\.\d+/))) {
				@domainbytes = split(/\./,$ENV{'REMOTE_ADDR'});
				$packaddr = pack("C4",@domainbytes);
				$resolvedip = (gethostbyaddr($packaddr, 2))[0];
				unless ($resolvedip =~
				  /^[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})$/) {
					$resolvedip = "";
				}
				if ($resolvedip) {
					$ENV{'REMOTE_HOST'} = $resolvedip;
				}
			}
		}
		else {
			$ENV{'REMOTE_HOST'} = "";
		}
		unless ($ENV{'REMOTE_HOST'}) { $ENV{'REMOTE_HOST'} = $ENV{'REMOTE_ADDR'}; }
		if ($FORM{'followup'}) { $followup = "$FORM{'followup'}"; }
		if ($FORM{'subject'}) { $subject = "$FORM{'subject'}"; }
		if ($subject && (%SmileyCode || $NM_Telltale || $Pic_Telltale)) {
			$subject =~ s/\&quot\;/"/g;
			$subject =~ s/\&lt\;/</g;
			$subject =~ s/\&gt\;/>/g;
			$subject =~ s/\&amp\;/\&/g;
			$realsubject = $subject;
			if (%SmileyCode) {
				foreach $key (keys %SmileyCode) {
					$key2 = $key;
					$key2 =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
					$subject =~ s/(^$key2)|([ \n]$key2)/ $SmileyCode{$key}/g;
				}
			}
			if ($NM_Telltale && (length($FORM{'body'})<4) && !($message_url)) {
				$subject .= " $NM_Telltale";
			}
			if ($Pic_Telltale && $image_url) {
				$subject .= " $Pic_Telltale";
			}
		}
		if ($FORM{'body'}) { $body = "$FORM{'body'}"; }
		unless ($name && $subject) { &Error("9200","9201"); }
		if ($FORM{'Preview'}) {
			&PreviewPost;
		}
		if ($FORM{'EditPost'}) {
			$num = $FORM{'EditPost'};
			$subdir = "bbs".int($num/1000);
			if (-e "$dir/$subdir/$num.tmp") {
				rename ("$dir/$subdir/$num.tmp","$dir/$subdir/$num");
				$EditApproval = 1;
			}
			open (FILE,"$dir/$subdir/$num") || &Error("9100","9101");
			@message = <FILE>;
			close (FILE);
			foreach $line (@message) {
				if (($line =~ /^DATE>/i)
				  || ($line =~ /^EMAILNOTICES>/i)
				  || ($line =~ /^IP_ADDRESS>/i)
				  || ($line =~ /^<!--/i)
				  || ($line =~ /^PASSWORD>/i)
				  || ($line =~ /^PREVIOUS>/i)
				  || ($line =~ /^NEXT>/i)) {
					$TransferIntact .= $line;
				}
			}
			$pdate=$psub=$pposter=$pprev=$pnext=$pcount=$padmin=$pip="";
			($pdate,$psub,$pposter,$pprev,$pnext,$pcount,$padmin,$pip) =
			  split(/\|/,$MessageList{$num});
			$FORM{'NewParent'} =~ s/ //g;
			unless ($FORM{'NewParent'} =~ /^\d+$/) {
				$FORM{'NewParent'} = $pprev;
			}
			unless ($FORM{'NewParent'} == $pprev) {
				$subdir = "bbs".int($pprev/1000);
				if ($pprev && (-e ("$dir/$subdir/$pprev"))) {
					&LockOpen (OLD,"$dir/$subdir/$pprev");
					@old = <OLD>;
					seek (OLD, 0, 0);
					foreach $line (@old) {
						chop $line;
						if ($line =~ /^NEXT>/i) {
							$line =~ s/$num//g;
						}
						print OLD "$line\n";
					}
					truncate (OLD, tell(OLD));
					&LockClose (OLD,"$dir/$subdir/$pprev");
					$mdate=$msub=$mposter=$mprev=$mnext=$mcount=$madmin=$mip="";
					($mdate,$msub,$mposter,$mprev,$mnext,$mcount,$madmin,$mip) =
					  split(/\|/,$MessageList{$pprev});
					$mnext =~ s/$num//g;
					delete ($MessageList{$pprev});
					foreach $key ($mdate,$msub,$mposter,$mprev,$mnext,$mcount,$madmin,$mip) {
						$MessageList{$pprev} .= "$key|";
					}
				}
				$subdir = "bbs".int($FORM{'NewParent'}/1000);
				if (-e ("$dir/$subdir/$FORM{'NewParent'}")) {
					&LockOpen (NEW,"$dir/$subdir/$FORM{'NewParent'}");
					@new = <NEW>;
					seek (NEW, 0, 0);
					foreach $line (@new) {
						chop $line;
						if ($line =~ /^NEXT>/i) {
							$line .= " $num";
						}
						print NEW "$line\n";
					}
					truncate (NEW, tell(NEW));
					&LockClose (NEW,"$dir/$subdir/$FORM{'NewParent'}");
					$mdate=$msub=$mposter=$mprev=$mnext=$mcount=$madmin=$mip="";
					($mdate,$msub,$mposter,$mprev,$mnext,$mcount,$madmin,$mip) =
					  split(/\|/,$MessageList{$FORM{'NewParent'}});
					$mnext .= " $num";
					delete ($MessageList{$FORM{'NewParent'}});
					foreach $key ($mdate,$msub,$mposter,$mprev,$mnext,$mcount,$madmin,$mip) {
						$MessageList{$FORM{'NewParent'}} .= "$key|";
					}
				}
				$TransferIntact =~ s/PREVIOUS>$pprev/PREVIOUS>$FORM{'NewParent'}/g;
			}
		}
		else {
			$new_body =
			  $name.$email.$subject.$body.$image_url.$message_url_title.$message_url;
			$new_body =~ s/\n/ /g;
			unless (-w "$dir") { &Error("9410","9411"); }
			open (DUPEDATA,"$dir/dupecheck.txt");
			$last_body = <DUPEDATA>;
			close (DUPEDATA);
			if ($last_body eq $new_body) { &Error("9500","9501"); }
			else {
				open (DUPEDATA,">$dir/dupecheck.txt");
				print DUPEDATA "$new_body";
				close (DUPEDATA);
			}
			unless (-e "$dir/data.txt") {
				open (NUMBER,">$dir/data.txt");
				print NUMBER "0";
				close (NUMBER);
			}
			&LockOpen (NUMBER,"$dir/data.txt");
			$num = <NUMBER>;
			$num++;
			seek (NUMBER, 0, 0);
			print NUMBER "$num";
			truncate (NUMBER, tell(NUMBER));
			&LockClose (NUMBER,"$dir/data.txt");
		}
		$subdir = "bbs".int($num/1000);
		unless (-d "$dir/$subdir") {
			mkdir ("$dir/$subdir",0777);
			chmod 0777,"$dir/$subdir";
		}
		open (MESSAGE,">$dir/$subdir/$num") || &Error("9400","9401","$dir/$subdir/$num");
		print MESSAGE "SUBJECT>$subject\n";
		if ($FORM{'Admin'} eq "AdminPost") {
			print MESSAGE "ADMIN>AdminPost\n";
		}
		print MESSAGE "POSTER>$name\n";
		print MESSAGE "EMAIL>$email\n";
		if ($FORM{'EditPost'}) {
			print MESSAGE "$TransferIntact";
		}
		else {
			print MESSAGE "DATE>$todaydate\n";
			unless ($FORM{'wantnotice'}) {
				print MESSAGE "EMAILNOTICES>no\n";
			}
			print MESSAGE "IP_ADDRESS>$ENV{'REMOTE_HOST'}\n";
			if ($ENV{'REMOTE_USER'}) {
				print MESSAGE "<!--$ENV{'REMOTE_USER'}-->\n";
			}
			if ($FORM{'password'}) {
				$password = crypt($FORM{'password'},"aa");
				print MESSAGE "PASSWORD>$password\n";
			}
			print MESSAGE "PREVIOUS>$followup\n";
			print MESSAGE "NEXT>\n";
		}
		print MESSAGE "IMAGE>$image_url\n";
		print MESSAGE "LINKNAME>$message_url_title\n";
		print MESSAGE "LINKURL>$message_url\n";
		print MESSAGE "$body\n";
		close (MESSAGE);
	}
	if ($FORM{'EditPost'}) {
		open (SEARCH,"$dir/searchterms.idx");
		&LockOpen (NEWSEARCH,"$dir/newsearchterms.idx");
		while (<SEARCH>) {
			if (/^(\d+) /) {
				$message = $1;
				$subdir = "bbs".int($message/1000);
				if ((-e "$dir/$subdir/$message") && ($message != $num)) {
					print NEWSEARCH "$_";
				}
			}
		}
		close (SEARCH);
		&LockOpen (SEARCH,"$dir/searchterms.idx");
		rename ("$dir/newsearchterms.idx","$dir/searchterms.idx");
		&LockClose (NEWSEARCH,"$dir/newsearchterms.idx");
		&LockClose (SEARCH,"$dir/searchterms.idx");
	}
	%wordlist = ();
	@words = ();
	&LockOpen (SEARCH,"$dir/searchterms.idx","a");
	print SEARCH "$num ";
	$line = "$subject $name $body";
	$line =~ s/<([^>]|\n)*>/ /g;
	$line =~ s/&[^;\s]*;/ /g;
	$line =~ s/[^\w\.\-\']/ /g;
	$line =~ s/(\s)+/ /g;
	$line =~ tr/A-Z/a-z/;
	@words = split (/\s/,$line);
	foreach $word (@words) {
		next if ($wordlist{$word});
		$wordlist{$word} = 1;
		print SEARCH "$word ";
	}
	print SEARCH "\n";
	&LockClose (SEARCH,"$dir/searchterms.idx");
	if ($followup) {
		$subdir = "bbs".int($followup/1000);
		open (FOLLOWUP,"$dir/$subdir/$followup");
		@followup_lines = <FOLLOWUP>;
		close (FOLLOWUP);
		open (FOLLOWUP,">$dir/$subdir/$followup");
		foreach $line (@followup_lines) {
			chop $line;
			if ($line =~ /^EMAILNOTICES>/i) {
				$fuwantnotice = "no";
			}
			elsif ($line =~ /^EMAIL>(.*)/i) {
				$fuemail = $1;
			}
			if ($line =~ /^NEXT>/) {
				print FOLLOWUP "$line $num\n";
			}
			else {
				print FOLLOWUP "$line\n";
			}
		}
		close (FOLLOWUP);
		$fudate=$fusub=$fuposter=$fuprev=$funext=$fucount=$fuadmin=$fuip="";
		($fudate,$fusub,$fuposter,$fuprev,$funext,$fucount,$fuadmin,$fuip) =
		  split(/\|/,$MessageList{$followup});
		$funext .= " $num";
		delete ($MessageList{$followup});
		foreach $key ($fudate,$fusub,$fuposter,$fuprev,$funext,$fucount,$fuadmin,$fuip) {
			$MessageList{$followup} .= "$key|";
		}
		$fusub =~ s/&pipe;/\|/g;
		$fuposter =~ s/&pipe;/\|/g;
	}
	if ($EditApproval) { $FORM{'EditPost'} = ""; }
	if ($mailprog && !($FORM{'EditPost'})) {
		$FORM{'subject'} = &UnWebify($FORM{'subject'});
		$FORM{'subject'} = substr($FORM{'subject'},0,50);
		$FORM{'name'} = &UnWebify($FORM{'name'});
		$FORM{'name'} = substr($FORM{'name'},0,15);
		$FORM{'body'} .= "\n";
		$FORM{'body'} = &UnWebify($FORM{'body'});
		$message_url_title = &UnWebify($message_url_title);
		$body = $text{'7000'}."\n\n".$text{'7001'}."\n\n";
		$body .= "$text{'7600'} (#$num) $FORM{'subject'}\n";
		$body .= "$text{'7603'} <$cgiurl?rev=$num>\n";
		$body .= "$text{'7601'} $FORM{'name'}";
		$body .= "\n";
		$body .= "$text{'7602'} ";
		$body .= &PrintDate($todaydate)."\n\n";
		if ($followup) {
			$subjectfu = &UnWebify($fusub);
			$subjectfu = substr($subjectfu,0,50);
			$posterfu = &UnWebify($fuposter);
			$posterfu = substr($posterfu,0,15);
			$body .= "$text{'7604'} (#$followup) $subjectfu\n";
			$body .= "$text{'7605'} $posterfu\n";
			$body .= "$text{'7606'} ";
			$body .= &PrintDate($fudate)."\n\n";
		}
		unless ($HeaderOnly) {
			$body .= $FORM{'body'}."\n";
			if ($message_url && $message_url_title) {
				$body .= "$text{'7607'} $message_url_title\n";
				$body .= "$text{'7608'} <$message_url>\n\n";
			}
		}
		$body .= $text{'7001'}."\n\n".$text{'7002'};
		$body .= "\n\n";
		@bodylines = split(/\n/,$body);
		$body = "";
		foreach $bodyline (@bodylines) {
			if ($bodyline =~ /^\./) {
				$bodyline = ".".$bodyline;
			}
			$quotewrap = 0;
			@quotedwords = split(/\s/,$bodyline);
			foreach $quotedword (@quotedwords) {
				$quotewrap += length($quotedword)+1;
				if ($quotewrap > 79) {
					if ($quotedword =~ /^\./) {
						$body .= "\n.$quotedword ";
					}
					else {
						$body .= "\n$quotedword ";
					}
					$quotewrap = length($quotedword)+1;
				}
				else {
					$body .= "$quotedword ";
				}
			}
			$body .= "\n";
		}
		$bcc = "";
		if ($email_list == 1) {
			if (-e "$dir/addresses.txt") {
				open (ADDRESSES,"$dir/addresses.txt");
				@addresses = <ADDRESSES>;
				close (ADDRESSES);
				foreach $address (@addresses) {
					chop $address;
					unless (($address =~
					  /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|,|;/
					  || $address !~
					  /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/)
					  || ($email && ($address =~ /$email/i))
					  || ($fuemail
					  && ($address =~ /$fuemail/i))) {
						$bcc .= ", ".$address;
					}
					if ($fuemail
					  && ($address =~ /$fuemail/i)) {
						$onrecipientlist = 1;
					}
				}
				$bcc =~ s/^, //;
			}
			&SendMail;
		}
		if ($fuemail) {
			$bcc = "";
			unless ((($fuwantnotice eq "no")
			  && !$onrecipientlist)
			  || ($fuemail eq $email)) {
				&SendMail($fuemail);
			}
		}
	}
	if ($MessageList{$num}>0) {
		$date=$sub=$poster=$prev=$next=$count=$admin=$ip="";
		($date,$sub,$poster,$prev,$next,$count,$admin,$ip) =
		  split(/\|/,$MessageList{$num});
		$todaydate = $date;
		if ($FORM{'NewParent'}) { $followup = $FORM{'NewParent'}; }
		else { $followup = $prev; }
		$ENV{'REMOTE_HOST'} = $ip;
	}
	else {
		$next = "";
		$count = "";
	}
	unless ($FORM{'Admin'} eq "AdminPost") { $FORM{'Admin'} = ""; }
	delete ($MessageList{$num});
	foreach $key ($todaydate,$subject,$name,$followup,$next,$count,$FORM{'Admin'},$ENV{'REMOTE_HOST'}) {
		$subject =~ s/\|/&pipe;/g;
		$name =~ s/\|/&pipe;/g;
		$MessageList{$num} .= "$key|";
	}
	&Header($text{'1600'},$MessageHeaderFile,"refreshalways","$num");
	$navbar = $NavBarStart;
	if ($UseFrames) {
		if ($FORM{'ApprovePost'} || $EditApproval) {
			$navbar .= " <A HREF=\"$adminurl$BBSquery";
			$navbar .= "moderate=0\" $BBStargettop>$text{'0025'}</A> |";
		}
		$navbar .= " <A HREF=\"$adminurl$BBSquery";
		$navbar .= "review=$num\" $BBStargettop>$text{'0004'} / ";
		$navbar .= "$text{'0011'}</A>";
	}
	else {
		if ($FORM{'ApprovePost'} || $EditApproval) {
			$navbar .= " <A HREF=\"$adminurl$BBSquery";
			$navbar .= "moderate=0\">$text{'0025'}</A> |";
		}
		$navbar .= " <A HREF=\"$adminurl$BBSquery";
		$navbar .= "read=$num\">$text{'0011'}</A> |";
		$navbar .= " <A HREF=\"$adminurl$BBSquery#$num\">";
		$navbar .= "$text{'0004'}</A>";
	}
	$navbar .= $NavBarEnd;
	print "$navbar";
	if ($printboardname) {
		print "<P ALIGN=CENTER><BIG><STRONG>";
		print "$boardname</STRONG></BIG>\n";
	}
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>";
	print "$text{'1600'}</STRONG></BIG></BIG>\n";
	print "<P ALIGN=CENTER>$text{'1601'}\n";
	&Footer($MessageFooterFile,"return","refreshalways");
}

sub SetAdminCookieData {
	%Cookie_Encode_Chars = (
	  '\%','%25','\+','%2B','\;','%3B','\,','%2C',
	  '\=','%3D','\&','%26','\:\:','%3A%3A','\s','+'
	  );
	%Cookie_Decode_Chars = (
	  '\+',' ','\%3A\%3A','::','\%26','&','\%3D','=',
	  '\%2C',',','\%3B',';','\%2B','+','\%25','%'
	  );
	&GetCookie($boardname);
	unless ($FORM{'ListType'}) {
		$FORM{'ListType'} = $Cookies{'listtype'};
	}
	unless ($FORM{'ListTime'}) {
		$FORM{'ListTime'} = $Cookies{'listtime'};
	}
	unless ($FORM{'password'}) {
		$FORM{'password'} = $Cookies{'password'};
	}
	if ($FORM{'KeySearch'} eq "No") {
		$listtype = $FORM{'ListType'};
		$listtime = $FORM{'ListTime'};
	}
	if ((!($UseFrames) && ($ENV{'QUERY_STRING'} =~ /review=(\d+)/i)) 
	  || (!($UseFrames) && ($ENV{'QUERY_STRING'} =~ /rev=(\d+)/i))
	  || ($ENV{'QUERY_STRING'} =~ /read=(\d+)/i)
	  || ($ENV{'QUERY_STRING'} =~ /moderate=(\d+)/i)
	  || ($ENV{'QUERY_STRING'} =~ /moderate/i)
	  || ($ENV{'QUERY_STRING'} =~ /topstats/i)
	  || ($ENV{'QUERY_STRING'} =~ /form=(\d+)/i)
	  || ($ENV{'QUERY_STRING'} =~ /edit=(\d+)/i)
	  || ($ENV{'QUERY_STRING'} =~ /resetpass/i)
	  || ($ENV{'QUERY_STRING'} =~ /addresslist/i)
	  || ($ENV{'QUERY_STRING'} =~ /subscribe/i)
	  || ($ENV{'QUERY_STRING'} =~ /search/i)
	  || ($ENV{'QUERY_STRING'} =~ /reconfigure/i)
	  || ($ENV{'QUERY_STRING'} =~ /delete/i)
	  || ($ENV{'QUERY_STRING'} =~ /profile/i)
	  || $FORM{'EditPost'} || $FORM{'ApprovePost'}) {
		return;
	}
	if ($ENV{'QUERY_STRING'} =~ /post/i) {
		unless ($FORM{'wantnotice'}) {
			$Cookies{'wantnotice'} = "no";
		}
		else { $Cookies{'wantnotice'} = "yes"; }
	}
	unless ($ENV{'QUERY_STRING'} =~ /post/i) {
		if (!$name) { $name = $Cookies{'name'}; }
		if (!$email) { $email = $Cookies{'email'}; }
		if (!$message_url) { $message_url = $Cookies{'linkurl'}; }
		if (!$message_url_title) { $message_url_title = $Cookies{'linkname'}; }
		if (!$image_url) {$image_url = $Cookies{'imageurl'}; }
	}
	if (!$listtype) { $listtype = $Cookies{'listtype'}; }
	if (!$listtime) { $listtime = $Cookies{'listtime'}; }
	unless ($Cookies{'thisvisit'}) {
		$Cookies{'thisvisit'} = $Cookies{'lastvisit'};
	}
	unless ($Cookies{'thismessage'}) {
		$Cookies{'thismessage'} = $Cookies{'lastmessage'};
	}
	if (($time - $Cookies{'timestamp'}) < 1800) {
		$lastvisit = $Cookies{'lastvisit'};
		$lastseen = $Cookies{'lastmessage'};
		$thisvisit = $Cookies{'thisvisit'};
		$thisseen = $Cookies{'thismessage'};
	}
	else {
		$lastvisit = $Cookies{'thisvisit'};
		$lastseen = $Cookies{'thismessage'};
		$Cookies{'lastvisit'} = $Cookies{'thisvisit'};
		$Cookies{'lastmessage'} = $Cookies{'thismessage'};
		$thisvisit = $todaydate;
		$thisseen = $lastmessage;
	}
	unless ($Cookies{'lastmessage'}) {
		$Cookies{'lastmessage'} = $lastmessage;
	}
	if ($SaveLinkInfo) {
		&SendCookie($boardname,'name',$name,'email',$email,
		  'listtype',$listtype,'listtime',$listtime,
		  'lastmessage',$lastseen,'lastvisit',$lastvisit,
		  'thismessage',$thisseen,'thisvisit',$thisvisit,
		  'timestamp',$time,'wantnotice',$Cookies{'wantnotice'},
		  'linkurl',$message_url,'linkname',$message_url_title,
		  'imageurl',$image_url,'password',$FORM{'password'});
	}
	else {
		&SendCookie($boardname,'name',$name,'email',$email,
		  'listtype',$listtype,'listtime',$listtime,
		  'lastmessage',$lastseen,'lastvisit',$lastvisit,
		  'thismessage',$thisseen,'thisvisit',$thisvisit,
		  'timestamp',$time,'wantnotice',$Cookies{'wantnotice'},
		  'password',$FORM{'password'});
	}
}

1;
