############################################
##                                        ##
##                 WebBBS                 ##
##           by Darryl Burgdorf           ##
##       (e-mail burgdorf@awsd.com)       ##
##                                        ##
##             version:  5.00             ##
##        last modified:  11/02/01        ##
##           copyright (c) 2001           ##
##                                        ##
##    latest version is available from    ##
##        http://awsd.com/scripts/        ##
##                                        ##
############################################

sub Startup {
	if ($UseFrames) { $AllowFramesChoice = $UseFrames; }
	if ($BannedIPsFile && ($BanLevel == 2)) {
		if ($ResolveIPs) {
			if (($ENV{'REMOTE_ADDR'} =~ /\d+\.\d+\.\d+\.\d+/)
			  && (!($ENV{'REMOTE_HOST'})
			  || ($ENV{'REMOTE_HOST'} =~ /\d+\.\d+\.\d+\.\d+/))) {
				@domainbytes = split(/\./,$ENV{'REMOTE_ADDR'});
				$packaddr = pack("C4",@domainbytes);
				$resolvedip = (gethostbyaddr($packaddr, 2))[0];
				unless ($resolvedip =~
				  /^[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,6}|[0-9]{1,3})$/) {
					$resolvedip = "";
				}
				if ($resolvedip) {
					$ENV{'REMOTE_HOST'} = $resolvedip;
				}
			}
		}
		else {
			$ENV{'REMOTE_HOST'} = "";
		}
		unless ($ENV{'REMOTE_HOST'}) { $ENV{'REMOTE_HOST'} = $ENV{'REMOTE_ADDR'}; }
		open (BANNED,"$BannedIPsFile");
		@bannedips = <BANNED>;
		close (BANNED);
		foreach $bannedip (@bannedips) {
			chomp ($bannedip);
			$bannedip =~ s/^([^\s]*)\s.*$/$1/g;
			next if (length($bannedip) < 2);
			if (($ENV{'REMOTE_HOST'} =~ /$bannedip/i)
			  || ($ENV{'REMOTE_ADDR'} =~ /$bannedip/i)) {
				require $webbbs_read;
				&Initialize_Data;
				&Error("9520","9521");
			}
		}
	}
	($SSIvirtual,$SSIfile,$SSIcgi,$PseudoQS) = (&FindSpecifics);
	unless ($ENV{'QUERY_STRING'}) {
		$ENV{'QUERY_STRING'} = $PseudoQS;
		$ENV{'QUERY_STRING'} =~ s/\//=/g;
		$ENV{'QUERY_STRING'} =~ s/^=*//g;
	}
	if ($ARGV[0] && !($ENV{'QUERY_STRING'})) {
		$ENV{'QUERY_STRING'} = $ARGV[0];
		$UseFrames = "";
		$SkipHF = 1;
	}
	if ($ENV{'QUERY_STRING'} =~ /noframes/i) { $UseFrames = ""; }
	if ((!($UseFrames) && ($ENV{'QUERY_STRING'} =~ /review=(\d+)/i)) 
	  || (!($UseFrames) && ($ENV{'QUERY_STRING'} =~ /rev=(\d+)/i)) 
	  || ($ENV{'QUERY_STRING'} =~ /read=(\d+)/i)
	  || ($ENV{'QUERY_STRING'} =~ /form=(\d+)/i)) {
		require $webbbs_read;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /profile/i) {
	  	require $webbbs_profile;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /post/i) {
		require $webbbs_post;
	}
	elsif (($ENV{'QUERY_STRING'} =~ /addresslist/i)
	  || ($ENV{'QUERY_STRING'} =~ /delete/i)
	  || ($ENV{'QUERY_STRING'} =~ /reconfigure/i)
	  || ($ENV{'QUERY_STRING'} =~ /search/i)
	  || ($ENV{'QUERY_STRING'} =~ /subscribe/i)
	  || ($ENV{'QUERY_STRING'} =~ /topstats/i)) {
		require $webbbs_misc;
	}
	else { require $webbbs_index; }
}

sub Parse_Form {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
	$RogueSpace = chr(160);
	foreach $pair (@pairs){
		($val1, $val2) = split(/=/, $pair);
		$val1 =~ tr/+/ /;
		$val1 =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$val2 =~ tr/+/ /;
		$val2 =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$val2 =~ s/\cM\n*/\n/g;
		$val2 =~ s/$RogueSpace/ /g;
		$val2 =~ s/<!--([^>]|\n)*-->/ /g;
		$val2 =~ s/<([^>]|\n)*(>|$)/ /g;
		$val2 =~ s/\&/\&amp\;/g;
		$val2 =~ s/"/\&quot\;/g;
		$val2 =~ s/</\&lt\;/g;
		$val2 =~ s/>/\&gt\;/g;
		if (($val1 eq "listitems")) {
			@listitems = split(/\n/,$val2);
		}
		$val2 =~ s/\n/ /g;
		$val2 =~ s/\s+/ /g;
		$val2 =~ s/^\s+//g;
		$val2 =~ s/\s+$//g;
		if ($FORM{$val1}) {
			$FORM{$val1} = "$FORM{$val1} $val2";
		}
		else {
			$FORM{$val1} = $val2;
		}
	}
}

sub Initialize_Data {
	umask (0111);
	if ($AdminRun) { $version = "Admin 5.00"; }
	else { $version = "5.00"; }
	$time = time;
	$todaydate = $time;
	$rebuildflag = 0;
	unless ($InputColumns) { $InputColumns = 80; }
	if ($InputColumns < 25) { $InputColumns = 25; }
	unless ($InputRows) { $InputRows = 15; }
	if ($InputRows < 5) { $InputRows = 5; }
	$InputLength = int($InputColumns/2);
	$TotalMessages = 0;
	$DisplayedMessages = 0;
	@messages = ();
	@sortedmessages = ();
	@keywordmatches = ();
	$matchstring = "\\w\\.\\-\\'";
	$datematchstring = "\\w\\.\\-\\'\\s\\(\\)";
	foreach $extrachar (keys %extrachars) {
		$matchstring .= "\\$extrachars{$extrachar}";
		$datematchstring .= "\\$extrachars{$extrachar}";
	}
	if ($SessionTime < 5) { $SessionTime = 30; }
	if ($SessionTime > 120) { $SessionTime = 30; }
	$SessionTime = $SessionTime * 60;
	$harvester_list = 'bullseye|cherrypicker|crescent|emailcollector|emailsiphon|emailwolf|extractor|microsoft url|mozilla/3.mozilla/2.01|newt|nicerspro|webbandit|brutus';
	$download_list = 'da \d|dnload|download|fetch|flashget|ftp|getright|gozilla|jetcar|leach|leech';
	$linkchecker_list = 'analyze|check|link|netmechanic|netmind|powermarks|redalert|tooter|validat|verif|walk';
	$offline_list = 'avantgo|batch|copier|httrack|msiecrawler|msproxy|netattache|netscape-proxy|offline|spacebison|teleport|webcapture|webzip';
	$spider_list = 'aport|archive|ask jeeves|behold|borg|bot|catch|crawl|digger|elitesys|enfish|esense|euroseek|ferret|grab|griffon|gulliver|harvest|htdig|hubat|hunt|infoseek|java|leia|lwp-|lwp:|mantraagent|mapper|mata hari|mercator|netants|perl|quest|reader|reaper|roamer|rover|scooter|search|slurp|snatch|spider|spinne|spyder|sweep|t-h-u-n-d-e-r-s-t-o-n-e|ultraseek|url|utopy|webcollage|webster pro|webwhacker|wfarc|wget|whatuseek';
	if ($AllowFramesChoice && $FORM{'UseFrames'}) {	
		if ($FORM{'UseFrames'} eq "Yes") {
			$UseFrames = $AllowFramesChoice;
			$ENV{'QUERY_STRING'} =~ s/noframes//g;
		}
		else {
			$UseFrames = "";
			$ENV{'QUERY_STRING'} .= ";noframes";
		}
	}
	if (($ENV{'HTTP_USER_AGENT'} =~ m#$harvester_list#oi)
	  || ($ENV{'HTTP_USER_AGENT'} =~ m#$download_list#oi)
	  || ($ENV{'HTTP_USER_AGENT'} =~ m#$linkchecker_list#oi)
	  || ($ENV{'HTTP_USER_AGENT'} =~ m#$offline_list#oi)
	  || ($ENV{'HTTP_USER_AGENT'} =~ m#$spider_list#oi)) {
		unless (($ENV{'HTTP_USER_AGENT'} =~ m#robotics#oi) || ($ENV{'HTTP_USER_AGENT'} =~ m#hotjava#oi)) {
			$CancelFrames = 1;
			$UseCookies = 0;
			$DisplayEmail = 0;
		}
	}
	$maillist_link = "<A HREF=\"mailto:$maillist_address\">";
	$maillist_link .= "$maillist_address<\/A>";
	if ($AdminRun) { $DestinationURL = $adminurl; }
	else { $DestinationURL = $cgiurl; }
	if ($ENV{'QUERY_STRING'}) { $NFQS = "noframes/$ENV{'QUERY_STRING'}"; }
	else { $NFQS = "noframes"; }
	$emailboardname = $boardname;
	$emailboardname =~ s/\&gt\;/>/g;
	$emailboardname =~ s/\&lt\;/</g;
	$emailboardname =~ s/\&quot\;/"/g;
	$emailboardname =~ s/\&amp\;/\&/g;
	foreach $key (keys %text) {
		$text{$key} =~ s/<!--boardname-->/$emailboardname/g;
		$text{$key} =~ s/<!--boardurl-->/$cgiurl/g;
		$text{$key} =~ s/<!--email-->/$maillist_address/g;
		$text{$key} =~ s/<!--emaillink-->/$maillist_link/g;
		$text{$key} =~ s/<!--NoFramesURL-->/<A HREF="$DestinationURL\/$NFQS">/g;
	}
	unless (($ENV{'DOCUMENT_URI'} && ($cgiurl !~ /$ENV{'DOCUMENT_URI'}/))
	  || ($ENV{'QUERY_STRING'} =~ /quickinfo/i)) {
		if (($ENV{'QUERY_STRING'} =~ /blank/i)
		  || ($UseFrames && !($ENV{'QUERY_STRING'}))
		  || ($UseFrames && ($ENV{'QUERY_STRING'} =~ /resetnew/i))
		  || ($UseFrames && ($ENV{'QUERY_STRING'} =~ /moderate=0/i))
		  || ($UseFrames && ($ENV{'QUERY_STRING'} =~ /review=/i))
		  || ($UseFrames && ($ENV{'QUERY_STRING'} =~ /rev=/i))
		  || ($UseFrames && ($ENV{'QUERY_STRING'} =~ /rebuild/i))) {
			if ($UseCookies) {
				if ($ENV{'QUERY_STRING'} =~ /resetnew/i) {
					$CookieResetNew = 1;
				}
				else {
					$CookieReadOnly = 1;
				}
				if ($AdminRun) { &SetAdminCookieData; }
				else { &SetCookieData; }
			}
			unless ($FORM{'UseFrames'} || ($Cookies{'UseFrames'} eq "No")) {
				if ($SearchFriendlyURLs) {
					$QS0 = "/"; $QS1 = "/"; $QS2 = "/";
					$BBSquery = "/";
				}
				else {
					$QS0 = "?"; $QS1 = ";"; $QS2 = "=";
					$BBSquery = "?";
				}
				$BBStarget = " TARGET=\"msgtxt\"";
				$BBStargetidx = " TARGET=\"msgidx\"";
				$BBStargettop = " TARGET=\"$BBSFrame\"";
				$SepPostFormIndex = 1;
				$SepPostFormRead = 1;
				print "Content-type: text/html\n";
				return;
			}
		}
	}
	if ($ArchiveOnly) {
		$AllowUserPrefs = 0;
		$UseCookies = 0;
	}
	if ($ListBullets) { $ul_dl = "UL"; $li_dd = "LI"; }
	else { $ul_dl = "DL"; $li_dd = "DD"; }
	$TableCellStart = "<FONT $tablefontspec>";
	$TableInputCellStart = "<FONT FACE=\"Courier\">";
	$NavBarStart = "<CENTER><P><TABLE $navbarspec><TR><TD ALIGN=CENTER>";
	$NavBarStart .= "<FONT $navbarfontspec><SMALL>";
	$NavBarEnd = " </SMALL></FONT></TD></TR></TABLE></CENTER>\n";
	$navbar = "";
	$CreditLink = "<P ALIGN=CENTER><SMALL><EM>$boardname $text{'9000'} ";
	unless ($admin_name) { $admin_name = $maillist_address; }
	if ($admin_name) {
		$CreditLink .= "$text{'9001'} ";
		if ($maillist_address) {
			$CreditLink .= "<A HREF=\"mailto:$maillist_address\">";
		}
		$CreditLink .= "$admin_name";
		if ($maillist_address) { $CreditLink .= "</A>"; }
		$CreditLink .= " ";
	}
	$CreditLink .= "$text{'9002'} <STRONG>";
	$CreditLink .= "<A HREF=\"http://awsd.com/scripts/webbbs/\" TARGET=\"_blank\">";
	$CreditLink .= "WebBBS $version</A></STRONG>.</EM></SMALL>\n";
	print "Content-type: text/html\n";
	use Fcntl;
	BEGIN { @AnyDBM_File::ISA = qw (DB_File GDBM_File SDBM_File ODBM_File NDBM_File) }
	if (eval "require DB_File") { @ISA = ('DB_File'); }
	else { use AnyDBM_File; $NotUsingBestDBM=1; }
	if ($AdminRun) {
		unless ($FORM{'UseFrames'} eq "Yes") {
			unless ($UseLocking) { &MasterLockOpen; }
			&LockOpen (DBLOCK,"$dir/dblock.txt");
			&MessageDBMWrite;
			if ($DisplayViews) {
				&LockOpen (COUNTLOCK,"$dir/countlock.txt");
				unless ($NoCountLock) {
					&CountDBMWrite;
				}
			}
		}
	}
	else {
		&MessageDBMRead;
	}
	@messages = (keys %MessageList);
	$TotalMessages = @messages;
	@sortedmessages = (sort {$a<=>$b} @messages);
	@messages = ();
	$lastmessage = $sortedmessages[@sortedmessages-1];
	if ($FORM{'ListSort'}) {
		if ($FORM{'ListDisplay'} eq "Guestbook") {
			if ($FORM{'ListType'} eq "By Threads") {
				$FORM{'ListType'} = "Guestbook-Style, Threaded";
			}
			elsif ($FORM{'ListType'} eq "Compressed") {
				$FORM{'ListType'} = "Guestbook-Style, Compressed";
			}
			else {
				$FORM{'ListType'} = "Guestbook-Style";
			}
		}
		if (($FORM{'ListType'} =~ /Thread/)
		 || ($FORM{'ListType'} =~ /Compressed/)) {
			if ($FORM{'ListSort'} eq "Reversed") {
				$FORM{'ListType'} .= ", Reversed";
			}
			elsif ($FORM{'ListSort'} eq "Mixed") {
				$FORM{'ListType'} .= ", Mixed";
			}
			elsif ($FORM{'ListSort'} eq "UBB") {
				$FORM{'ListType'} .= ", UBB";
			}
		}
		else {
			unless ($FORM{'ListSort'} eq "Standard") {
				$FORM{'ListType'} .= ", Reversed";
			}
		}
	}
	if ($FORM{'ListTimeB'} && $FORM{'ListType'} && !($AllowUserPrefs)) {
		$FORM{'ListTimeA'}=$FORM{'ListTimeB'}="";
		$FORM{'ListType'}=$FORM{'ListSize'}="";
	}
	if ($FORM{'ListTimeB'}) {
		$FORM{'ListTimeA'} = int($FORM{'ListTimeA'});
		if ($FORM{'ListTimeA'} < 1) { $FORM{'ListTimeA'} = 1; }
		$FORM{'ListTime'} = "$FORM{'ListTimeA'} $FORM{'ListTimeB'}";
	}
	if ($FORM{'ListSize'} eq "New") {
		$FORM{'ListTime'} = "New Only";
	}
	$name = "";
	if ($LockRemoteUser && $ENV{'REMOTE_USER'}) {
		$name = $ENV{'REMOTE_USER'};
	}
	else {
		if ($FORM{'name'}) { $name = "$FORM{'name'}"; }
		$name = substr($name,0,$MaxInputLength);
	}
	if ($name) { $Cookies{'name'} = $name; }
	$email = "";
	$FORM{'email'} =~ s/\s//g;
	unless ($FORM{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|,|;|\//
	  || $FORM{'email'} !~
	  /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,6}|[0-9]{1,3})(\]?)$/)
	  {
		$email = "$FORM{'email'}";
	}
	if (length($email) > 100) { $email = ""; }
	if ($email) { $Cookies{'email'} = $email; }
	$FORM{'url'} =~ s/\&amp\;/\&/g;
	$FORM{'url'} =~ s/\s//g;
	$FORM{'imageurl'} =~ s/\&amp\;/\&/g;
	$FORM{'imageurl'} =~ s/\s//g;
	unless ($FORM{'url'} =~ /(\.\.)|(^\.)|(\/\/\.)/
	  || $FORM{'url'} !~ /.*\:\/\/.*\..*/) {
		$message_url = "$FORM{'url'}";
		if ($FORM{'url_title'}) {
			$message_url_title = "$FORM{'url_title'}";
		}
		else {
			$message_url_title = "$FORM{'url'}";
		}
	}
	unless ($FORM{'imageurl'} =~ /(^\.)|(\/\/\.)/
	  || $FORM{'imageurl'} !~ /.*\:\/\/.*\..*/
	  || $FORM{'imageurl'} =~ /script:/) {
		$image_url = "$FORM{'imageurl'}";
	}
	if (length($message_url) > 250) { $message_url = ""; }
	if (length($image_url) > 250) { $image_url = ""; }
	if ($message_url) { $Cookies{'linkurl'} = $message_url; }
	if ($message_url_title) { $Cookies{'linkname'} = $message_url_title; }
	if ($image_url) { $Cookies{'imageurl'} = $image_url; }
	if (($FORM{'newpass1'}) || ($FORM{'newpass2'})) {
		unless ($FORM{'newpass1'} eq $FORM{'newpass2'}) {
			&Error("9602","9603");
		}
		$FORM{'oldpassword'} = $FORM{'password'};
		$FORM{'password'} = $FORM{'newpass1'};
	}
	if ($CookieReadOnly) { $CookieReadOnly = 0; $CookieAlreadyRead = 1; }
	if ($UseCookies && !($CookieResetNew)) {
		if ($AdminRun) { &SetAdminCookieData; }
		else { &SetCookieData; }
	}
	if ($name && !($AdminRun) && $RequireEmail) {
		$ProfileCheck = $name;
		$ProfileCheck =~ s/[^\w\.\-\']/\+/g;
		$ProfileCheck =~ tr/A-Z/a-z/;
		if (-e "$UserProfileDir/$ProfileCheck.txt") {
			open (FILE,"$UserProfileDir/$ProfileCheck.txt") || &Error("9110","9111");
			@message = <FILE>;
			close (FILE);
			$email = "";
			$Cookies{'email'} = "";
			foreach $line (@message) {
				if ($line =~ /^EMAIL>(.*)/i) { $email = $1; last; }
			}
			if ($email) { $Cookies{'email'} = $email; }
		}
	}
	if ($Cookies{'UseFrames'} eq "No") {
		$ENV{'QUERY_STRING'} .= ";noframes";
	}
	if (($ENV{'QUERY_STRING'} =~ /noframes/i)
	  || ($ENV{'DOCUMENT_URI'} && ($cgiurl !~ /$ENV{'DOCUMENT_URI'}/))
	  || ($ENV{'QUERY_STRING'} =~ /quickinfo/i)
	  || ($CancelFrames)) {
		$UseFrames = "";
		$FORM{'UseFrames'} = "No";
		if ($SearchFriendlyURLs) {
			$QS0 = "/"; $QS1 = "/"; $QS2 = "/";
			$BBSquery = "/noframes/";
		}
		else {
			$QS0 = "?"; $QS1 = ";"; $QS2 = "=";
			$BBSquery = "?noframes;";
		}
	}
	else {
		if ($SearchFriendlyURLs) {
			$QS0 = "/"; $QS1 = "/"; $QS2 = "/";
			$BBSquery = "/";
		}
		else {
			$QS0 = "?"; $QS1 = ";"; $QS2 = "=";
			$BBSquery = "?";
		}
	}
	if ($UseFrames) {
		$BBStarget = " TARGET=\"msgtxt\"";
		$BBStargetidx = " TARGET=\"msgidx\"";
		$BBStargettop = " TARGET=\"$BBSFrame\"";
		$SepPostFormIndex = 1;
		$SepPostFormRead = 1;
	}
	else {
		$BBStarget = "";
		$BBStargetidx = "";
		$BBStargettop = "";
	}
	unless ($FORM{'ListTime'}) { $FORM{'ListTime'} = $DefaultTime; }
	unless ($FORM{'ListTime'}) { $FORM{'ListTime'} = "2 $text{'0062'}"; }
	unless ($FORM{'ListType'}) { $FORM{'ListType'} = $DefaultType; }
	if ($AlphaSortMessages && ($FORM{'ListType'} !~ /Alpha/)) {
		$FORM{'ListType'} = "Alphabetically";
	}
	elsif (!($AlphaSortMessages) && ($FORM{'ListType'} =~ /Alpha/)) {
		$FORM{'ListType'} = "";
	}
	unless ($FORM{'ListType'}) { $FORM{'ListType'} = "Chronologically"; }
	if ((($FORM{'ListType'} =~ /Guestbook/)
	  || ($FORM{'ListType'} =~ /Compress/))
	  && ($IndexEntryLines eq "news")) {
		$IndexEntryLines = 2;
	}
	unless ($DateConfig) {
		$DateConfig = "%DY%, %dy% %MO% %YR%, at %hr%:%mn% %am%";
	}
	unless ($NewOpenCode || $NewCloseCode) {
		$NewOpenCode = "<EM><FONT COLOR=\"#cc0000\">NEW:</FONT></EM>";
	}
	unless ($AdminOpenCode || $AdminCloseCode) {
		$AdminOpenCode = "<EM><FONT COLOR=\"#990000\">ADMIN!</FONT></EM>";
	}
	unless ($AutoQuoteChar) { $AutoQuoteChar = ":"; }
	if ($NM_Telltale) {
		$Cleaned_NM_Telltale = $NM_Telltale;
		$Cleaned_NM_Telltale =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
	}
	if ($Pic_Telltale) {
		$Cleaned_Pic_Telltale = $Pic_Telltale;
		$Cleaned_Pic_Telltale =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
	}
}

sub PrintDate {
	unless ($_[0] =~ /^\d+$/) {
		return $_[0];
	}
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
	  localtime($_[0]+($HourOffset*3600));
	if ($sec < 10) { $sec = "0$sec"; }
	if ($min < 10) { $min = "0$min"; }
	$hour24 = $hour;
	if ($hour24 < 10) { $hour24 = "0$hour24"; }
	$ampm = "a.m.";
	if ($hour eq 12) { $ampm = "p.m."; }
	if ($hour eq 0) { $hour = "12"; }
	if ($hour > 12) { $hour = ($hour - 12); $ampm = "p.m."; }
	$month = $months[$mon];
	$mon ++;
	$yearlong = $year+1900;
	if ($year > 99) { $year = $year-100; }
	if ($year < 10) { $year = "0$year"; }
	$wday = $days[$wday];
	$datestring = $DateConfig;
	$datestring =~ s/%mo%/$mon/g;
	$datestring =~ s/%MO%/$month/g;
	$datestring =~ s/%dy%/$mday/g;
	$datestring =~ s/%DY%/$wday/g;
	$datestring =~ s/%yr%/$year/g;
	$datestring =~ s/%YR%/$yearlong/g;
	$datestring =~ s/%am%/$ampm/g;
	$datestring =~ s/%sc%/$sec/g;
	$datestring =~ s/%mn%/$min/g;
	$datestring =~ s/%hr%/$hour/g;
	$datestring =~ s/%HR%/$hour24/g;
	return $datestring;
}

sub FindStart {
	$threadstart = $_[0];
	local ($date,$sub,$poster,$prev,$next,$count,$admin,$ip) = "";
	($date,$sub,$poster,$prev,$next,$count,$admin,$ip) =
	  split(/\|/,$MessageList{$threadstart});
	if ($FORM{'ListType'} =~ /UBB/) {
		if ($sortorder{$threadstart} < $date) {
			$sortorder{$threadstart} = $date;
		}
	}
	if ($prev && ($MessageList{$prev}>0)) {
		if ($FORM{'ListType'} =~ /UBB/) {
			if ($sortorder{$prev} < $sortorder{$threadstart}) {
				$sortorder{$prev} = $sortorder{$threadstart};
			}
		}
		&FindStart($prev);
	}
}

sub ThreadList {
	local (@threadresponses);
	local (@reversethread);
	local ($date,$sub,$poster,$prev,$next,$count,$admin,$ip) = "";
	($date,$sub,$poster,$prev,$next,$count,$admin,$ip) =
	  split(/\|/,$MessageList{$_[0]});
	&PrintMessageDesc($_[0]);
	if ($IndexEntryLines eq "news") {
		$indexspacer .= " &nbsp; &nbsp; &nbsp;";
	}
	else {
		print "<$ul_dl>\n";
	}
	@threadresponses = split(/ /,$next);
	if ($FORM{'ListType'} =~ /Reversed/) {
		@reversethread = reverse(@threadresponses);
		@threadresponses = @reversethread;
	}
	$lastresponse = "";
	foreach $threadresponse (@threadresponses) {
		next unless ($threadresponse > $_[0]);
		next if ($threadresponse eq $lastresponse);
		if (($MessageList{$threadresponse}>0)
		  && !($DontUse{$threadresponse})) {
			&ThreadList($threadresponse);
			$lastresponse = $threadresponse;
		}
	}
	if ($IndexEntryLines eq "news") {
		$indexspacer =~ s/ &nbsp; &nbsp; &nbsp;$//;
	}
	else {
		print "</$ul_dl>\n";
	}
	$already{$_[0]} = 1;
}

sub PrintMessageDesc {
	local ($date,$sub,$poster,$prev,$next,$count,$admin,$ip) = "";
	($date,$sub,$poster,$prev,$next,$count,$admin,$ip) =
	  split(/\|/,$MessageList{$_[0]});
	$sub =~ s/&pipe;/\|/g;
	$poster =~ s/&pipe;/\|/g;
	if ($IndexEntryLines eq "news") {
		print "<TR><TD>$TableCellStart";
		print "$indexspacer";
		if ($AdminRun) {
			if ($DeleteSelect) {
				print "<INPUT TYPE=CHECKBOX ";
				print "NAME=\"delete\" VALUE=\"$_[0]\"> ";
			}
			$ToBeDeleted .= " $_[0]";
		}
		if ($admin eq "AdminPost") { print "$AdminOpenCode "; }
		if (($Cookies{'lastmessage'}
		  && ($Cookies{'lastmessage'} < $_[0]))
		  || ($newcount{$_[0]} > 0)) {
			print "$NewOpenCode ";
		}
		unless (($messagenumber == $_[0]) || ($sub eq $text{'0250'})) {
			print "<A NAME=$_[0] HREF=\"$DestinationURL$BBSquery";
			print "read"."$QS2"."$_[0]";
			if ($FORM{'ListType'} =~ /Guestbook-Style, Threaded/) {
				print "#$_[0]";
			}
			elsif ($FORM{'ListType'} =~ /Guestbook-Style, Compressed/) {
				if (($firstnew{$_[0]} > 0) && ($firstnew{$_[0]} < 1000000000)) {
					print "#$firstnew{$_[0]}";
				}
			}
			print "\"$BBStarget>";
		}
		print "$sub";
		unless (($messagenumber == $_[0]) || ($sub eq $text{'0250'})) {
			print "</A>";
		}
		if (($CountList{$_[0]} > 0) && ($DisplayViews == 1)) {
			unless (($FORM{'ListType'} =~ /Compress/)
			  || ($FORM{'ListType'} =~ /Guest/)) {
				print " <SMALL>($text{'1010'}: $CountList{$_[0]})</SMALL>";
			}
		}
		if (($Cookies{'lastmessage'}
		  && ($Cookies{'lastmessage'} < $_[0]))
		  || ($newcount{$_[0]} > 0)) {
			print " $NewCloseCode";
		}
		if ($admin eq "AdminPost") { print " $AdminCloseCode"; }
		print "</FONT></TD><TD>$TableCellStart";
		print "$poster ";
		if ($DisplayIPs && $ip) {
			print " <SMALL><EM>($ip)</EM></SMALL> ";
		}
		print "</FONT></TD><TD>$TableCellStart",&PrintDate($date);
		print "</FONT></TD></TR>\n";
	}
	else {
		print "<$li_dd>";
		if ($AdminRun) {
			if ($DeleteSelect) {
				print "<INPUT TYPE=CHECKBOX ";
				print "NAME=\"delete\" VALUE=\"$_[0]\"> ";
			}
			$ToBeDeleted .= " $_[0]";
		}
		print "<STRONG>";
		if ($admin eq "AdminPost") { print "$AdminOpenCode "; }
		if (($Cookies{'lastmessage'}
		  && ($Cookies{'lastmessage'} < $_[0]))
		  || ($newcount{$_[0]} > 0)) {
			print "$NewOpenCode ";
		}
		unless (($messagenumber == $_[0]) || ($sub eq $text{'0250'})) {
			print "<A NAME=$_[0] HREF=\"$DestinationURL$BBSquery";
			print "read"."$QS2"."$_[0]";
			if ($FORM{'ListType'} =~ /Guestbook-Style, Threaded/) {
				print "#$_[0]";
			}
			elsif ($FORM{'ListType'} =~ /Guestbook-Style, Compressed/) {
				if (($firstnew{$_[0]} > 0) && ($firstnew{$_[0]} < 1000000000)) {
					print "#$firstnew{$_[0]}";
				}
			}
			print "\"$BBStarget>";
		}
		print "$sub";
		unless (($messagenumber == $_[0]) || ($sub eq $text{'0250'})) {
			print "</A>";
		}
		print "</STRONG>";
		if (($CountList{$_[0]} > 0) && ($DisplayViews == 1)) {
			unless (($FORM{'ListType'} =~ /Compress/)
			  || ($FORM{'ListType'} =~ /Guest/)) {
				print " <SMALL>($text{'1010'}: $CountList{$_[0]})</SMALL>";
			}
		}
		if ($IndexEntryLines == 1) {
			print " -- ";
		}
		else {
			print "<BR>";
		}
		print "$poster ";
		if ($DisplayIPs && $ip) {
			print " <SMALL><EM>($ip)</EM></SMALL> ";
		}
		print "-- ",&PrintDate($date);
		if (($Cookies{'lastmessage'}
		  && ($Cookies{'lastmessage'} < $_[0]))
		  || ($newcount{$_[0]} > 0)) {
			print " $NewCloseCode";
		}
		if ($admin eq "AdminPost") { print " $AdminCloseCode"; }
		print "\n";
	}
}

sub PrintGuestbookDesc {
	$messagenumber = $_[0];
	print "<A NAME=$messagenumber>\n";
	print "$GuestbookOpen";
	local($date,$sub,$poster,$prev,$next,$count,$admin,$ip) = "";
	($date,$sub,$poster,$prev,$next,$count,$admin,$ip) =
	  split(/\|/,$MessageList{$messagenumber});
	if ($DisplayViews) {
		unless ($CountList{$messagenumber}) { $CountList{$messagenumber} = 0; }
		$CountList{$messagenumber}++;
	}
	$subdir = "bbs".int($messagenumber/1000);
	open (FILE,"$dir/$subdir/$messagenumber") || return;
	@message = <FILE>;
	close (FILE);
	$startup = 0;
	$admin=$subject=$poster=$email=$date=$image_url=$linkname=$linkurl="";
	foreach $line (@message) {
		if ($line =~ /^SUBJECT>(.*)/i) { $subject = $1; }
		elsif ($line =~ /^ADMIN>AdminPost/i) { $admin = "AdminPost"; }
		elsif ($line =~ /^ADMIN>/i) { next; }
		elsif ($line =~ /^POSTER>(.*)/i) { $poster = $1; }
		elsif ($line =~ /^EMAIL>(.*)/i) { $email = $1; }
		elsif ($line =~ /^DATE>(.*)/i) { $date = $1; }
		elsif ($line =~ /^EMAILNOTICES>/i) { next; }
		elsif ($line =~ /^IP_ADDRESS>(.*)/i) { $ipaddress = $1; }
		elsif ($line =~ /^<!--/i) { next; }
		elsif ($line =~ /^PASSWORD>(.*)/i) { $oldpassword = $1; }
		elsif ($line =~ /^PREVIOUS>(.*)/i) { $previous = $1; }
		elsif ($line =~ /^NEXT>(.*)/i) { $next = $1; }
		elsif ($line =~ /^IMAGE>(.*)/i) { $image_url = $1; }
		elsif ($line =~ /^LINKNAME>(.*)/i) { $linkname = $1; }
		elsif ($line =~ /^LINKURL>(.*)/i) { $linkurl = $1; }
		elsif (!$startup) {
			$startup = 1;
			print "<P ALIGN=CENTER>";
			print "<STRONG><BIG>";
			if ($admin eq "AdminPost") { print "$AdminOpenCode "; }
			if (($Cookies{'lastmessage'}
			  && ($Cookies{'lastmessage'} < $_[0]))
			  || ($newcount{$_[0]} > 0)) {
				print "$NewOpenCode ";
			}
			print "$subject";
			print "</BIG></STRONG>";
			print "<BR>";
			$ProfileCheck = $poster;
			$ProfileCheck =~ s/[^\w\.\-\']/\+/g;
			$ProfileCheck =~ tr/A-Z/a-z/;
			if (-e "$UserProfileDir/$ProfileCheck.txt") {
				print "<A HREF=\"$DestinationURL$BBSquery";
				print "profile"."$QS2"."$ProfileCheck\" TARGET=\"_blank\">";
				print "$poster</A>";
			}
			else { print "$poster"; }
			if ($DisplayEmail && $email) {
				$mailsubject = $subject;
				if (%SmileyCode) {
					foreach $key (keys %SmileyCode) {
						$key2 = $SmileyCode{$key};
						$key2 =~ s/([\[\]\(\)\\\*\+\?\\\|])/\\$1/g;
						$mailsubject =~ s/$key2/$key/g;
					}
				}
				$mailsubject =~ s/"/'/g;
				print " &lt;<A HREF=\"mailto:$email?subject=$mailsubject\">";
				print "$email</A>&gt;";
			}
			if ($DisplayIPs && $ipaddress) {
				print " <SMALL><EM>($ipaddress)</EM></SMALL> ";
			}
			print " -- <EM>",&PrintDate($date),"</EM>";
			if (($Cookies{'lastmessage'}
			  && ($Cookies{'lastmessage'} < $_[0]))
			  || ($newcount{$_[0]} > 0)) {
				print " $NewCloseCode\n";
			}
			if ($admin eq "AdminPost") { print " $AdminCloseCode"; }
			print "$MessageOpenCode\n";
			print $line;
		}
		else { print $line; }
	}
	print "$MessageCloseCode\n";
	if ($image_url) {
		print "<P ALIGN=CENTER>";
		print "<IMG SRC=\"$image_url\">\n";
	}
	if ($linkurl) {
		print "<P ALIGN=CENTER>";
		print "<EM><A HREF=\"$linkurl\" ";
		print "TARGET=\"_blank\">";
		print "$linkname</A></EM>\n";
	}
	unless ($ArchiveOnly || (!($AllowResponses))) {
		print "$NavBarStart$navbaropen<A HREF=\"$cgiurl$BBSquery";
		print "form=$messagenumber\"";
		print "$BBStargettop>$text{'0003'}</A>$navbarclose$NavBarEnd";
	}
	print "$GuestbookClose";
}

sub GetCookie {
	local($cookie_name) = @_;
	local($cookie,$value);
	if ($ENV{'HTTP_COOKIE'}) {
		foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
			($cookie,$value) = split(/=/);
			foreach $char ('\+','\%3A\%3A','\%26','\%3D','\%2C','\%3B','\%2B','\%25') {
				$cookie =~ s/$char/$Cookie_Decode_Chars{$char}/g;
				$value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
			}
			if (($cookie eq "WebBBS Master")
			  || ($cookie eq $cookie_name)) {
				$Cookies{$cookie} = $value;
			}
		}
	}
	if ($Cookies{'WebBBS Master'}) {
		foreach (split(/&/,$Cookies{'WebBBS Master'})) {
			($cookie,$value) = split(/::/);
			foreach $char ('\+','\%3A\%3A','\%26','\%3D','\%2C','\%3B','\%2B','\%25') {
				$cookie =~ s/$char/$Cookie_Decode_Chars{$char}/g;
				$value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
			}
			$Cookies{$cookie} = $value;
		}
	}
	if ($Cookies{$cookie_name}) {
		foreach (split(/&/,$Cookies{$cookie_name})) {
			($cookie,$value) = split(/::/);
			foreach $char ('\+','\%3A\%3A','\%26','\%3D','\%2C','\%3B','\%2B','\%25') {
				$cookie =~ s/$char/$Cookie_Decode_Chars{$char}/g;
				$value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
			}
			$Cookies{$cookie} = $value;
		}
	}
	delete ($Cookies{'WebBBS Master'});
	delete ($Cookies{$cookie_name});
	if ($Cookies{'em'}) { $Cookies{'email'} = $Cookies{'em'}; }
	if ($Cookies{'iu'}) { $Cookies{'imageurl'} = $Cookies{'iu'}; }
	if ($Cookies{'ln'}) { $Cookies{'linkname'} = $Cookies{'ln'}; }
	if ($Cookies{'lu'}) { $Cookies{'linkurl'} = $Cookies{'lu'}; }
	if ($Cookies{'m1'}) { $Cookies{'lastmessage'} = $Cookies{'m1'}; }
	if ($Cookies{'m2'}) { $Cookies{'thismessage'} = $Cookies{'m2'}; }
	if ($Cookies{'nm'}) { $Cookies{'name'} = $Cookies{'nm'}; }
	if ($Cookies{'pw'}) { $Cookies{'password'} = $Cookies{'pw'}; }
	if ($Cookies{'tm'}) { $Cookies{'listtime'} = $Cookies{'tm'}; }
	if ($Cookies{'tp'}) { $Cookies{'listtype'} = $Cookies{'tp'}; }
	if ($Cookies{'ts'}) { $Cookies{'timestamp'} = $Cookies{'ts'}; }
	if ($Cookies{'uf'}) { $Cookies{'UseFrames'} = $Cookies{'uf'}; }
	if ($Cookies{'v1'}) { $Cookies{'lastvisit'} = $Cookies{'v1'}; }
	if ($Cookies{'v2'}) { $Cookies{'thisvisit'} = $Cookies{'v2'}; }
	if ($Cookies{'wn'}) { $Cookies{'wantnotice'} = $Cookies{'wn'}; }
}

sub WriteCookie {
	$CookiePW = $FORM{'password'};
	if ($FORM{'CookiePW'} eq "No") { $CookiePW = ""; }
	if ($IsolateCookies) {
		if ($SaveLinkInfo) {
			&SendCookie($boardname,'nm',$name,'em',$email,'tp',$listtype,'tm',$listtime,
			  'm1',$lastseen,'v1',$lastvisit,'m2',$thisseen,'v2',$thisvisit,
			  'ts',$time,'wn',$Cookies{'wantnotice'},'pw',$CookiePW,
			  'lu',$message_url,'ln',$message_url_title,'iu',$image_url,
			  'uf',$Cookies{'UseFrames'});
		}
		else {
			&SendCookie($boardname,'nm',$name,'em',$email,'tp',$listtype,'tm',$listtime,
			  'm1',$lastseen,'v1',$lastvisit,'m2',$thisseen,'v2',$thisvisit,
			  'ts',$time,'wn',$Cookies{'wantnotice'},'pw',$CookiePW,
			  'uf',$Cookies{'UseFrames'});
		}
	}
	else {
		if ($SaveLinkInfo) {
			&SendCookie('WebBBS Master','nm',$name,'em',$email,
			  'wn',$Cookies{'wantnotice'},'pw',$CookiePW,
			  'lu',$message_url,'ln',$message_url_title,'iu',$image_url,
			  'uf',$Cookies{'UseFrames'});
			&SendCookie($boardname,'tp',$listtype,'tm',$listtime,
			  'm1',$lastseen,'v1',$lastvisit,'m2',$thisseen,'v2',$thisvisit,
			  'ts',$time);
		}
		else {
			&SendCookie('WebBBS Master','nm',$name,'em',$email,
			  'wn',$Cookies{'wantnotice'},'pw',$CookiePW,
			  'uf',$Cookies{'UseFrames'});
			&SendCookie($boardname,'tp',$listtype,'tm',$listtime,
			  'm1',$lastseen,'v1',$lastvisit,'m2',$thisseen,'v2',$thisvisit,
			  'ts',$time);
		}
	}
}

sub SendCookie {
	local($cookie_name,@cookies) = @_;
	local($cookie,$value,$cookie_value,$char);
	while (($cookie,$value) = @cookies) {
		foreach $char ('\%','\+','\;','\,','\=','\&','\:\:','\s') {
			$cookie =~ s/$char/$Cookie_Encode_Chars{$char}/g;
			$value =~ s/$char/$Cookie_Encode_Chars{$char}/g;
		}
		if ($cookie_value) {
			$cookie_value .= '&' . $cookie . '::' . $value;
		}
		else {
			$cookie_value = $cookie . '::' . $value;
		}
		shift(@cookies); shift(@cookies);
	}
	foreach $char ('\%','\+','\;','\,','\=','\&','\:\:','\s') {
		$cookie_name =~ s/$char/$Cookie_Encode_Chars{$char}/g;
		$cookie_value =~ s/$char/$Cookie_Encode_Chars{$char}/g;
	}
	print 'Set-Cookie: ' . $cookie_name . '=' . $cookie_value . ';';
	print ' expires=Fri, 31-Dec-2010 00:00:00 GMT;';
	print ' path=/;';
	print "\n";
}

sub Error {
	local ($error_title, $error_text, $error_file) = @_;
	if (($error_title eq "9120")
	  || ($error_title eq "9200") || ($error_title eq "9250")
	  || ($error_title eq "9500") || ($error_title eq "9510")) {
		$SpellCheckerMeta = 1;
		$PreviewForm = 1;
		&Header($text{$error_title},$MessageHeaderFile);
		&Header2;
	}
	else {
		&Header($text{$error_title},$MessageHeaderFile,"refresh");
		&Header2("refresh");
	}
	if ($error_title eq "9150") {
		opendir (MESSAGES,$dir);
		@messagedir = readdir(MESSAGES);
		closedir (MESSAGES);
		foreach $message (@messagedir) {
			if ($message =~ /^messagelist/) {
				unlink "$dir/$message";
			}
		}
	}
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>$text{$error_title}</STRONG></BIG></BIG>\n";
	if (length($error_file) > 2) {
		print "<P ALIGN=CENTER>$error_file\n";
	}
	print "<P>$text{$error_text} $text{'9999'}\n";
	return unless ($error_title < 9700);
	if ($PreviewForm) {
		$body = $BodyPreview;
		$body =~ s/\& /\&amp\; /g;
		$body =~ s/"/\&quot\;/g;
		$body =~ s/</\&lt\;/g;
		$body =~ s/>/\&gt\;/g;
		if ($realsubject) {
			$subject = $realsubject;
			$subject =~ s/\& /\&amp\; /g;
			$subject =~ s/"/\&quot\;/g;
			$subject =~ s/</\&lt\;/g;
			$subject =~ s/>/\&gt\;/g;
		}
		require $webbbs_form;
		&Print_Form(-1);
		print "<P>&nbsp;";
	}
	if ($PreviewForm) { &Footer($MessageFooterFile,"return"); }
	else { &Footer($MessageFooterFile,"return","refresh"); }
}

sub FindSpecifics {
	$ADVNoPrint = 1;
	$DOMAIN = $ENV{'HTTP_HOST'};
	$ROOT_URL = "http://$DOMAIN";
	if ($ENV{'REQUEST_URI'} =~ /\.pl(\/.*)$/) { $PSEUDO_QS = $1; }
	elsif ($ENV{'REQUEST_URI'} =~ /\.cgi(\/.*)$/) { $PSEUDO_QS = $1; }
	if ($ENV{'SCRIPT_NAME'} && $ENV{'PATH_INFO'}) {
		unless ($PSEUDO_QS) { $PSEUDO_QS = $ENV{'PATH_INFO'}; }
		$URI_PATH = $ENV{'SCRIPT_NAME'};
	}
	elsif ($ENV{'PATH_INFO'}) { $URI_PATH = $ENV{'PATH_INFO'}; }
	elsif ($ENV{'SCRIPT_NAME'}) { $URI_PATH = $ENV{'SCRIPT_NAME'}; }
	$URI_DIR = $URI_PATH;
	$URI_DIR =~ s/^(.*?)\/[^\/\\]*\.[^\.\/]+$/$1/;
	unless($URI_DIR){ $URI_DIR = "/"; }
	if ($ENV{'DOCUMENT_ROOT'}) { $DOC_ROOT = $ENV{'DOCUMENT_ROOT'}; }
	elsif ($ENV{'PWD'}) { $DOC_ROOT = $ENV{'PWD'}; }
	else { $DOC_ROOT = $ENV{'PATH_TRANSLATED'}; }
	$DOC_ROOT =~ tr/\\/\//;
	$DOC_ROOT =~ s/^(.+?)$URI_PATH$/$1/;
	$DOC_ROOT =~ s/^(.+?)$URI_DIR(\/)*$/$1/;
	$DOC_ROOT =~ s/^(.+?)\/$/$1/;
	$CGI_ROOT = $DOC_ROOT;
	while ($CGI_ROOT && !$CGIOK) {
		if (-e "$CGI_ROOT/cgi-bin") { $CGIOK = 1; }
		else { $CGI_ROOT =~ s/^(.*)\/[^\/\\]*$/$1/; }
	}
	unless ($CGI_ROOT) { $CGI_ROOT = $DOC_ROOT; }
	$THIS_DIR = $URI_DIR;
	$THIS_DIR =~ s/^$ROOT_URL//i;
	$THIS_DIR = "$DOC_ROOT/$THIS_DIR";
	$THIS_DIR =~ s/\/\//\//g;
	$THIS_DIR =~ s/\/$//;
	return ($DOC_ROOT,$THIS_DIR,$CGI_ROOT,$PSEUDO_QS);
}

sub SSI_Functions {
	my $PASSED = @_[0];
	$PASSED =~ s/</\n</;
	$PASSED =~ s/>/>\n/;
	my @PASSED = split(/\n/,$PASSED);
	my (@included,$included,$included_line,$exec_line,@EXECD,$execd);
	foreach $PASSED (@PASSED) {
		$PASSED =~ s/<!--\s*#\s*echo \s*var\s*=\s*"(.+?)"\s*-->/$ENV{$1}/i;
		if (!($AdminRun) && ($PASSED =~ /<!--InsertAdvert\s*(.*)-->/i)) {
			&insertadvert($1);
		}
		if ($PASSED =~ s/<!--\s*#\s*include \s*virtual\s*=\s*"(.+?)"\s*-->//i) {
			open (INCLUDED,"$SSIvirtual$1");
			@included=<INCLUDED>;
			close (INCLUDED);
			foreach $included (@included) {
				$included =~ s/\n$//;
				&SSI_Functions($included);
				$PASSED = "";
			}
		}
		if ($PASSED =~ s/<!--\s*#\s*include \s*file\s*=\s*"(.+?)"\s*-->//i) {
			open (INCLUDED,"$SSIfile/$1");
			@included=<INCLUDED>;
			close (INCLUDED);
			foreach $included_line (@included) {
				$included_line =~ s/\n$//;
				&SSI_Functions($included_line);
				$PASSED = "";
			}
		}
		if ($PASSED =~ s/<!--\s*#\s*exec \s*cgi\s*=\s*"(.+?)"\s*-->//i) {
			open (EXECD,"$SSIcgi$1");
			@EXECD = <EXECD>;
			close (EXECD);
			foreach $exec_line (@EXECD) {
				if ($exec_line =~ "Content-type") { $exec_line = ""; }
				if ($exec_line =~ "exit;") { $exec_line = ""; }
			}
			my $execd = join(/\n/, @EXECD);
			eval($execd);
			$PASSED = "";
		}
		if ($PASSED =~ s/<!--\s*#\s*exec \s*cmd\s*=\s*"(.+?)"\s*-->//i) {
			($cmd,$path) = split (/ /,$1);
			if ((-e $path) && ($cmd =~ /^perl$/i)) {
				$execute = $path;
				$ok = 1;
			} 
			elsif ((-e $cmd) && (!$path)) {
				$execute = $cmd;
				$ok = 1;
			}
			if ($ok) {
				open (EXECD, "$execute");
				@EXECD = <EXECD>;
				close (EXECD);
				$execd = join(/\n/, @EXECD);
				eval($execd);
			}
			$PASSED = "";
		}
		$PASSED =~ s/\n$//s;
		if ($PASSED) { print "$PASSED\n"; }
	}
}

sub Header {
	local ($header_title, $header_file,$refresh,$destname) = @_;
	$header_title =~ s/<([^>]|\n)*(>|$)/ /g;
	print "\n<HTML><HEAD>";
	if ($RefreshTime && (($refresh eq "refreshalways")
	  || (($refresh eq "refresh") && !($UseFrames)))) {
		print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$RefreshTime; URL=$DestinationURL$BBSquery";
		if ($AdminRun
		  && (($FORM{'delete'} =~ /tmp/) || $FORM{'ApprovePost'} || $EditApproval)) {
			print "moderate"."$QS2"."0;";
		}
		if ($destname) {
			if ($UseFrames) {
				print "review"."$QS2"."$destname";
				if ($FORM{'ListType'} =~ /Guestbook-Style, Threaded/) {
					print "#$message";
				}
			}
			else { print "#$destname"; }
		}
		print "\">";
	}
	print "<TITLE>$header_title</TITLE>\n";
	if (!($SkipHF) && $SpellCheckerID && $SpellCheckerPath && $SpellCheckerMeta) {
		if ($SpellCheckerJS) {
			print "<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"javascript\" ";
			print "SRC=\"$SpellCheckerJS\"></SCRIPT>\n";
		}
		else {
			print "<SCRIPT LANGUAGE=\"javascript\" ";
			print "SRC=\"http://www.spellchecker.net/spellcheck/lf/spch.cgi?";
			print "customerid=$SpellCheckerID\"></SCRIPT>\n";
		}
	}
	if (!($SkipHF) && $MetaFile) {
		open (HEADLN,"$MetaFile");
		@headln = <HEADLN>;
		close (HEADLN);
		foreach $line (@headln) { &SSI_Functions($line); }
	}
	print "</HEAD><BODY $bodyspec><FONT $fontspec>\n";
	if (!($SkipHF) && $header_file) {
		open (HEADER,"$header_file");
		@header = <HEADER>;
		close (HEADER);
		foreach $line (@header) { &SSI_Functions($line); }
	}
}

sub Header2 {
	local ($refresh) = @_;
	if (($refresh eq "refresh") || !($UseFrames)) {
		if ($AdminRun) {
			$navbar = $NavBarStart;
			if ($FORM{'delete'} =~ /tmp/) {
				$navbar .= "$navbaropen<A HREF=\"$adminurl$BBSquery";
				$navbar .= "moderate"."$QS2"."0\"";
				if ($UseFrames) { $navbar .= "$BBStargettop>"; }
				else { $navbar .= ">"; }
				$navbar .= "$text{'0025'}</A>$navbarclose";
			}
			$navbar .= "$navbaropen<A HREF=\"$adminurl$BBSquery\"";
		}
		else {
			$navbar = $NavBarStart."$navbaropen<A HREF=\"$cgiurl$BBSquery\"";
		}
		if ($UseFrames) { $navbar .= "$BBStargettop>"; }
		else { $navbar .= ">"; }
		$navbar .= "$text{'0004'}</A>$navbarclose";
		$navbar .= $NavBarEnd;
		print "$navbar";
		if ($printboardname && !($UseFrames)) {
			print "<P ALIGN=CENTER><BIG><STRONG>";
			print "$boardname</STRONG></BIG>\n";
		}
	}
}

sub Footer {
	local ($footer_file,$footer_type,$refresh) = @_;
	if ($RefreshTime && (($refresh eq "refreshalways")
	  || (($refresh eq "refresh") && !($UseFrames)))) {
		print "<SMALL>\n<P ALIGN=CENTER><EM>$text{'0150'}</EM>\n</SMALL>\n";
	}
	elsif ($navbar && !$refresh) { print "$navbar"; }
	if ($footer_type eq "credits") {
		print "$CreditLink";
	}
	if (!($SkipHF) && $footer_file) {
		open (FOOTER,"$footer_file");
		@footer = <FOOTER>;
		close (FOOTER);
		foreach $line (@footer) { &SSI_Functions($line); }
	}
	print "</FONT></BODY></HTML>\n";
	if ($DBMType==2) {
		dbmclose (%MessageList);
		dbmclose (%CountList);
	}
	else {
		untie %MessageList;
		untie %CountList;
	}
	&LockClose (DBLOCK,"$dir/dblock.txt");
	&LockClose (COUNTLOCK,"$dir/countlock.txt");
	unless ($UseLocking) { &MasterLockClose; }
	reset 'A-Za-z';
	exit;
}

sub commas {
	local($_)=@_;
	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

sub MessageDBMRead {
	if ($DBMType==1) {
		tie (%MessageList,'AnyDBM_File',"$dir/messagelist",O_RD,0666,$DB_HASH);
	}
	elsif ($DBMType==2) {
		dbmopen(%MessageList,"$dir/messagelist",0666);
	}
	else {
		tie (%MessageList,'AnyDBM_File',"$dir/messagelist",O_RD,0666);
	}
}

sub MessageDBMWrite {
	if ($DBMType==1) {
		tie (%MessageList,'AnyDBM_File',"$dir/messagelist",O_RDWR|O_CREAT,0666,$DB_HASH)
		  || &Error("9150","9151");
	}
	elsif ($DBMType==2) {
		dbmopen(%MessageList,"$dir/messagelist",0666)
		  || &Error("9150","9151");
	}
	else {
		tie (%MessageList,'AnyDBM_File',"$dir/messagelist",O_RDWR|O_CREAT,0666)
		  || &Error("9150","9151");
	}
}

sub CountDBMRead {
	if ($DBMType==1) {
		tie (%CountList,'AnyDBM_File',"$dir/countlist",O_RD,0666,$DB_HASH);
	}
	elsif ($DBMType==2) {
		dbmopen(%CountList,"$dir/countlist",0666);
	}
	else {
		tie (%CountList,'AnyDBM_File',"$dir/countlist",O_RD,0666);
	}
}

sub CountDBMWrite {
	if ($DBMType==1) {
		tie (%CountList,'AnyDBM_File',"$dir/countlist",O_RDWR|O_CREAT,0666,$DB_HASH)
		  || &Error("9150","9151");
	}
	elsif ($DBMType==2) {
		dbmopen(%CountList,"$dir/countlist",0666)
		  || &Error("9150","9151");
	}
	else {
		tie (%CountList,'AnyDBM_File',"$dir/countlist",O_RDWR|O_CREAT,0666)
		  || &Error("9150","9151");
	}
}

sub LockOpen {
	local(*FILE,$lockfilename,$append) = @_;
	unless (-e "$lockfilename") {
		open (FILE,">$lockfilename");
		print FILE "\n";
		close (FILE);
	}
	if ($append) {
		open (FILE,">>$lockfilename") || &Error("9400","9401",$lockfilename);
	}
	else {
		open (FILE,"+<$lockfilename") || &Error("9400","9401",$lockfilename);
	}
	if ($UseLocking) {
		local($TrysLeft) = 3000;
		while ($TrysLeft--) {
			select(undef,undef,undef,0.01);
			(flock(FILE,6)) || next;
			last;
		}
		unless ($TrysLeft >= 0) {
			if ($lockfilename =~ /countlock.txt/) {
				$NoCountLock = 1;
			}
			else {
				&Error("9400","9401",$lockfilename);
			}
		}
	}
}

sub LockClose {
	local(*FILE,$lockfilename) = @_;
	close (FILE);
}

sub MasterLockOpen {
	local($TrysLeft) = 6000;
	if ((-e "$dir/masterlockfile.lok")
	  && ((stat("$dir/masterlockfile.lok"))[9]+15<$time)) {
		unlink ("$dir/masterlockfile.lok");
	}
	while ($TrysLeft--) {
		if (-e "$dir/masterlockfile.lok") {
			select(undef,undef,undef,0.01);
		}
		else {
			open (MASTERLOCKFILE,">$dir/masterlockfile.lok");
			print MASTERLOCKFILE "\n";
			close (MASTERLOCKFILE);
			last;
		}
	}
	unless ($TrysLeft >= 0) {
		$UseLocking = 1;
		&Error("9400","9401","$dir/masterlockfile.lok");
	}
}

sub MasterLockClose {
	unlink ("$dir/masterlockfile.lok");
}

1;
