############################################
##                                        ##
##                 WebBBS                 ##
##           by Darryl Burgdorf           ##
##       (e-mail burgdorf@awsd.com)       ##
##                                        ##
##             version:  5.00             ##
##        last modified:  11/02/01        ##
##           copyright (c) 2001           ##
##                                        ##
##    latest version is available from    ##
##        http://awsd.com/scripts/        ##
##                                        ##
############################################

sub WebBBS {
	&Parse_Form;
	&Initialize_Data;
	if ($ENV{'QUERY_STRING'} =~ /addresslist/i) { &UpdateAddressList; }
	elsif ($ENV{'QUERY_STRING'} =~ /delete/i) {
		if ($DBMType==2) { dbmclose (%MessageList); }
		else { untie %MessageList; }
		unless ($UseLocking) { &MasterLockOpen; }
		&LockOpen (DBLOCK,"$dir/dblock.txt");
		&MessageDBMWrite;
		&Delete;
	}
	elsif ($ENV{'QUERY_STRING'} =~ /reconfigure/i) { &Reconfigure; }
	elsif ($ENV{'QUERY_STRING'} =~ /search/i) { &Search; }
	elsif ($ENV{'QUERY_STRING'} =~ /subscribe/i) { &Subscribe; }
	else { &TopStats; }
}

sub TopStats {
	foreach $message (@sortedmessages) {
		$date=$sub=$poster=$prev=$next=$count=$admin=$ip="";
		($date,$sub,$poster,$prev,$next,$count,$admin,$ip) =
		  split(/\|/,$MessageList{$message});
		$poster =~ s/&pipe;/\|/g;
		$posterlc = $poster;
		$posterlc =~ tr/A-Z/a-z/;
		unless ($PosterCount{$posterlc}) {
			$PosterCount++;
			$Name{$posterlc} = $poster;
		}
		if ($posterlc ne $poster) {
			$Name{$posterlc} = $poster;
		}
		$PosterCount{$posterlc}++;
		if ($date > $LastDate{$poster}) {
			$LastPost{$posterlc} = $message;
			$LastDate{$posterlc} = $date;
		}
	}
	&Header($text{'3001'},$MessageHeaderFile);
	&Header2;
	print "<CENTER>\n";
	if ($AdminRun) {
		print "<P><BIG><BIG><STRONG>$text{'3001'}</STRONG></BIG></BIG>\n";
	}
	else {
		print "<P><BIG><BIG><STRONG>$text{'3000'} $TopNPosters $text{'3001'}</STRONG></BIG></BIG>\n";
	}
	print "<P><STRONG>$text{'3002'}:</STRONG> ",&commas($TotalMessages)," ";
	print "<STRONG>| $text{'3003'}:</STRONG> ",&commas($PosterCount),"\n";
	if ($PosterCount == 0) {
		&Footer($MessageFooterFile,"credits");
	}
	$average = int(($TotalMessages/$PosterCount)+.5);
	print "<BR><STRONG>$text{'3004'}:</STRONG> ",&commas($average),"\n";
	print "<P><TABLE BORDER=0 CELLSPACING=0 CELLPADDING=3>\n";
	print "<TR VALIGN=BOTTOM><TH ALIGN=LEFT><FONT $fontspec>";
	print "$text{'3005'}<BR><HR NOSHADE></FONT></TH><TD>&nbsp;</TD>";
	print "<TH ALIGN=RIGHT><FONT $fontspec>";
	print "$text{'3006'}<BR><HR NOSHADE></FONT></TH><TD>&nbsp;</TD>";
	print "<TH ALIGN=RIGHT><FONT $fontspec>";
	print "$text{'3007'}<BR><HR NOSHADE></FONT></TH><TD>&nbsp;</TD>";
	print "<TH ALIGN=LEFT><FONT $fontspec>";
	print "$text{'3008'}<BR><HR NOSHADE></FONT></TH></TR>\n";
	if ($AdminRun && $UserProfileDir) {
		opendir (PROFILES,$UserProfileDir);
		@profiles = readdir(PROFILES);
		closedir (PROFILES);
		foreach $profile (@profiles) {
			if ($profile =~ /^(.*)\.txt$/) { $ProfileList{$1} = 1; }
		}
	}
	foreach $key (sort ByPostCount keys(%PosterCount)) {
		unless ($AdminRun) {
			$postercounter++;
			last if ($postercounter > $TopNPosters);
		}
		print "<TR><TD NOWRAP><FONT $fontspec>";
		$ProfileCheck = $key;
		$ProfileCheck =~ s/[^\w\.\-\']/\+/g;
		$ProfileCheck =~ tr/A-Z/a-z/;
		if (-e "$UserProfileDir/$ProfileCheck.txt") {
			print "<A HREF=\"$DestinationURL$BBSquery";
			if ($AdminRun) {
				print "profileedit"."$QS2"."$ProfileCheck\"$BBStargettop";
			}
			else {
				print "profile"."$QS2"."$ProfileCheck\" TARGET=\"_blank\"";
			}
			print ">$Name{$key}</A>";
			$ProfileList{$ProfileCheck} = 0;
		}
		else { print "$Name{$key}"; }
		print "</FONT></TD><TD>&nbsp;</TD>";
		print "<TD ALIGN=RIGHT><FONT $fontspec>";
		print &commas($PosterCount{$key}),"</FONT></TD><TD>&nbsp;</TD>";
		$percent = (($PosterCount{$key}/$TotalMessages)*100)+0.0051;
		if ($percent < 10) { $percent =~ s/(....).*/$1/; }
		else { $percent =~ s/(.....).*/$1/; }
		print "<TD ALIGN=RIGHT><FONT $fontspec>";
		print "${percent}%</FONT></TD><TD>&nbsp;</TD>";
		print "<TD NOWRAP><FONT $fontspec><A HREF=\"$DestinationURL$BBSquery";
		print "read"."$QS2"."$LastPost{$key}\"$BBStarget>";
		print &PrintDate($LastDate{$key}),"</A></FONT></TD></TR>\n";
	}
	if ($AdminRun) {
		foreach $key (keys(%ProfileList)) {
			next if ($ProfileList{$key} < 1);
			print "<TR><TD NOWRAP><FONT $fontspec>";
			print "<A HREF=\"$DestinationURL$BBSquery";
			print "profileedit"."$QS2"."$key\"$BBStargettop>";
			print "$key</A>";
			print "</FONT></TD><TD>&nbsp;</TD>";
			print "<TD ALIGN=RIGHT><FONT $fontspec>";
			print "0</FONT></TD><TD>&nbsp;</TD>";
			print "<TD ALIGN=RIGHT><FONT $fontspec>";
			print "</FONT></TD><TD>&nbsp;</TD>";
			print "<TD NOWRAP><FONT $fontspec></A></FONT></TD></TR>\n";
		}
	}
	print "</TABLE></CENTER>\n";
	&Footer($MessageFooterFile,"credits");
}

sub ByPostCount {
	$PosterCount{$b}<=>$PosterCount{$a};
}

sub Delete {
	$PassCheck = 0;
	unless ($FORM{'newpassword'}) { &Error("9600","9601"); }
	$newpassword = crypt($FORM{'newpassword'},"aa");
	$message = $FORM{'delete'};
	$subdir = "bbs".int($message/1000);
	unless (-e "$dir/$subdir/$message") { &Error("9600","9601"); }
	$oldpassword = "";
	open (FILE,"$dir/$subdir/$message");
	@message = <FILE>;
	close (FILE);
	foreach $line (@message) {
		if ($line =~ /^POSTER>(.*)/i) {
			$deleteposter = $1;
		}
		if ($line =~ /^PASSWORD>(.*)/i) {
			$oldpassword = $1;
			last;
		}
	}
	if (($oldpassword) && ($newpassword eq $oldpassword)) {
		$PassCheck = 1;
	}
	if (!($PassCheck) && ($deleteposter eq $Cookies{'name'})) {
		$oldpassword = "";
		@message = ();
		$ProfileCheck = $Cookies{'name'};
		$ProfileCheck =~ s/[^\w\.\-\']/\+/g;
		$ProfileCheck =~ tr/A-Z/a-z/;
		if (-e "$UserProfileDir/$ProfileCheck.txt") {
			open (FILE,"$UserProfileDir/$ProfileCheck.txt");
			@message = <FILE>;
			close (FILE);
			foreach $line (@message) {
				if ($line =~ /^PASSWORD>(.*)/i) {
					$oldpassword = $1;
					last;
				}
			}
		}
		if (($oldpassword) && ($newpassword eq $oldpassword)) {
			$PassCheck = 1;
		}
	}
	unless ($PassCheck == 1) {
		unless (-e "$dir/password.txt") {
			&Error("9600","9601");
		}
		open (PASSWORD, "$dir/password.txt");
		$password = <PASSWORD>;
		close (PASSWORD);
		chomp ($password);
		unless ($newpassword eq $password) {
			&Error("9600","9601");
		}
		$DeleteByAdmin = 1;
	}
	if ($DeleteByAdmin) {
		unlink "$dir/$subdir/$message";
		delete ($MessageList{$message});
	}
	else {
		open (MESSAGE,"$dir/$subdir/$message");
		@message = <MESSAGE>;
		close (MESSAGE);
		open (MESSAGE,">$dir/$subdir/$message");
		foreach $line (@message) {
			if ($line =~ /^SUBJECT>/) {
				print MESSAGE "SUBJECT>$text{'0250'}\n";
			}
			elsif (($line =~ /^POSTER>/)
			  || ($line =~ /^DATE>/)
			  || ($line =~ /^IP_ADDRESS>/)
			  || ($line =~ /^<!--/)
			  || ($line =~ /^PREVIOUS>/)
			  || ($line =~ /^NEXT>/)) {
				print MESSAGE "$line";
			}
		}
		print MESSAGE "\n";
		close (MESSAGE);
		($deldate,$delsub,$delposter,$delprev,$delnext,$delcount,$deladmin,$delip) =
		  split(/\|/,$MessageList{$message});
		delete ($MessageList{$message});
		$delsub = $text{'0250'};
		foreach $key ($deldate,$delsub,$delposter,$delprev,$delnext,$delcount,$deladmin,$delip) {
			$MessageList{$message} .= "$key|";
		}
	}
	if ($DisplayViews) {
		&LockOpen (COUNTLOCK,"$dir/countlock.txt");
		unless ($NoCountLock) {
			&CountDBMWrite;
		}
		if ($CountList{$message}) { delete ($CountList{$message}); }
	}
	open (SEARCH,"$dir/searchterms.idx");
	&LockOpen (NEWSEARCH,"$dir/newsearchterms.idx");
	while (<SEARCH>) {
		if (/^(\d+) /) {
			$message = $1;
			$subdir = "bbs".int($message/1000);
			if (-e "$dir/$subdir/$message") {
				print NEWSEARCH "$_";
			}
		}
	}
	close (SEARCH);
	if ($ENV{'OS'} =~ /win/i) {
		&LockClose (NEWSEARCH,"$dir/newsearchterms.idx");
	}
	else {
		&LockOpen (SEARCH,"$dir/searchterms.idx");
	}
	rename ("$dir/newsearchterms.idx","$dir/searchterms.idx");
	unless ($ENV{'OS'} =~ /win/i) {
		&LockClose (NEWSEARCH,"$dir/newsearchterms.idx");
		&LockClose (SEARCH,"$dir/searchterms.idx");
	}
	&Header($text{'0212'},$MessageHeaderFile,"refresh");
	&Header2("refresh");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>$text{'0212'}</STRONG></BIG></BIG>\n";
	print "<P ALIGN=CENTER>$text{'0200'}\n";
	&Footer($MessageFooterFile,"return","refresh");
}

sub Subscribe {
	&Header($text{'4000'},$MessageHeaderFile);
	&Header2;
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>";
	print "$text{'4000'}</STRONG></BIG></BIG>\n";
	print "<P>$text{'4001'} ";
	if ($email_list == 1) { print "$text{'4002'} "; }
	else { print "$text{'4003'} "; }
	print "$text{'4004'}\n";
	print "<FORM METHOD=POST ACTION=\"$DestinationURL$BBSquery";
	print "addresslist\"$BBStarget>\n";
	print "<P><CENTER>$text{'4005'}: ";
	print "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=\"email\" SIZE=30";
	if ($Cookies{'email'}) {
		print " VALUE=\"$Cookies{'email'}\"";
	}
	print "></FONT> <INPUT TYPE=SUBMIT VALUE=\"$text{'4008'}\">\n";
	print "<BR><INPUT TYPE=RADIO NAME=\"action\" ";
	print "VALUE=\"add\" CHECKED> $text{'4006'} ";
	print "<INPUT TYPE=RADIO NAME=\"action\" ";
	print "VALUE=\"delete\"> $text{'4007'}";
	print "</CENTER></FORM>\n";
	&Footer($MessageFooterFile,"credits");
}

sub SetCookieData {
	%Cookie_Encode_Chars = (
	  '\%','%25','\+','%2B','\;','%3B','\,','%2C',
	  '\=','%3D','\&','%26','\:\:','%3A%3A','\s','+'
	  );
	%Cookie_Decode_Chars = (
	  '\+',' ','\%3A\%3A','::','\%26','&','\%3D','=',
	  '\%2C',',','\%3B',';','\%2B','+','\%25','%'
	  );
	&GetCookie($boardname);
	unless ($FORM{'ListType'}) {
		$FORM{'ListType'} = $Cookies{'listtype'};
	}
	unless ($FORM{'ListTime'}) {
		$FORM{'ListTime'} = $Cookies{'listtime'};
	}
	unless ($FORM{'password'}) {
		$FORM{'password'} = $Cookies{'password'};
	}
	if (!$name) { $name = $Cookies{'name'}; }
	if (!$email) { $email = $Cookies{'email'}; }
}

sub Search {
	&Header("$boardname - $text{'6000'}",$MessageHeaderFile);
	&Header2;
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>$text{'6001'}</STRONG></BIG></BIG>\n";
	print "<P>$text{'6002'}\n";
	print "<FORM METHOD=POST ACTION=\"$DestinationURL$BBSquery";
	print "index\"$BBStargetidx>\n";
	print "<CENTER>";
	if ($FORM{'ListTime'} =~ /(\d+) ([\w\(\)]+)/) {
		$FORM{'ListTimeA'} = $1;
		$FORM{'ListTimeB'} = $2;
	}
	else {
		$FORM{'ListTimeA'} = 2;
		$FORM{'ListTimeB'} = "$text{'0062'}";
	}
	print "<P><EM>$text{'6003'}:</EM>";
	unless ($ArchiveOnly) {
		print "<BR><INPUT TYPE=RADIO NAME=ListSize VALUE=Recent";
		print " CHECKED> $text{'6004'} ";
		print "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=\"ListTimeA\" SIZE=2 ";
		print "VALUE=$FORM{'ListTimeA'}> ";
		print "<SELECT NAME=\"ListTimeB\"><OPTION";
		if ($FORM{'ListTimeB'} eq "$text{'0060'}") {
			print " SELECTED";
		}
		print ">$text{'0060'}<OPTION";
		if ($FORM{'ListTimeB'} eq "$text{'0061'}") {
			print " SELECTED";
		}
		print ">$text{'0061'}<OPTION";
		if ($FORM{'ListTimeB'} eq "$text{'0062'}") {
			print " SELECTED";
		}
		print ">$text{'0062'}<OPTION";
		if ($FORM{'ListTimeB'} eq "$text{'0063'}") {
			print " SELECTED";
		}
		print ">$text{'0063'}</SELECT></FONT>\n";
		print "<BR><INPUT TYPE=RADIO NAME=ListSize VALUE=Range>";
	}
	else {
		print "<BR><INPUT TYPE=HIDDEN NAME=ListSize VALUE=Range>";
	}
	print " $text{'6005'} ";
	($mday,$mon,$year) =
	  (localtime(int($MessageList{$sortedmessages[0]})+($HourOffset*3600)))[3,4,5];
	print "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=\"StartDateA\" SIZE=2 VALUE=$mday> ";
	print "<SELECT NAME=\"StartDateB\">";
	foreach $key (0..11) {
		print "<OPTION VALUE=\"$key\"";
		if ($key == $mon) { print " SELECTED"; }
		print ">$months[$key]";
	}
	print "</SELECT> ";
	print "<INPUT TYPE=TEXT NAME=\"StartDateC\" SIZE=4 VALUE=",$year+1900,"></FONT>";
	print " $text{'6006'} ";
	($mday,$mon,$year) =
	  (localtime(int($MessageList{$sortedmessages[@sortedmessages-1]})+($HourOffset*3600)))[3,4,5];
	print "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=\"EndDateA\" SIZE=2 VALUE=$mday> ";
	print "<SELECT NAME=\"EndDateB\">";
	foreach $key (0..11) {
		print "<OPTION VALUE=\"$key\"";
		if ($key == $mon) { print " SELECTED"; }
		print ">$months[$key]";
	}
	print "</SELECT> ";
	print "<INPUT TYPE=TEXT NAME=\"EndDateC\" SIZE=4 VALUE=",$year+1900,"></FONT>\n";
	print "<SMALL>\n<P>$text{'6007'}: ";
	($mday,$mon,$year) =
	  (localtime(int($MessageList{$sortedmessages[0]})+($HourOffset*3600)))[3,4,5];
	print "$mday $months[$mon] ",$year+1900;
	print "<BR>$text{'6008'}: ";
	($mday,$mon,$year) =
	  (localtime(int($MessageList{$sortedmessages[@sortedmessages-1]})+($HourOffset*3600)))[3,4,5];
	print "$mday $months[$mon] ",$year+1900;
	print "\n</SMALL>\n";
	print "<P><EM>$text{'6009'}:</EM>",
	  "<BR><INPUT TYPE=RADIO NAME=\"KeySearch\" ",
	  "VALUE=\"All\"> $text{'6010'}\n",
	  "<BR><INPUT TYPE=RADIO NAME=\"KeySearch\" ",
	  "VALUE=\"Yes\" CHECKED> $text{'6011'} <FONT FACE=\"Courier\"><SELECT ",
	  "NAME=\"Boolean\"><OPTION SELECTED>$text{'0051'}",
	  "<OPTION>$text{'0050'}</SELECT></FONT> $text{'6012'}:",
	  "<BR><FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=\"Keywords\" ",
	  "SIZE=50></FONT>\n",
	  "<BR><INPUT TYPE=RADIO NAME=\"KeySearch\" ",
	  "VALUE=\"Author\"> $text{'6013'}: <FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=\"Author\" SIZE=25></FONT>\n";
	if ($AdminRun) {
		print "<BR><INPUT TYPE=RADIO NAME=\"KeySearch\" ",
		  "VALUE=\"Domain\"> $text{'6013'} $text{'6015'}: <FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
		  "NAME=\"Domain\" SIZE=10></FONT>\n";
	}
	print "<P><INPUT TYPE=SUBMIT VALUE=\"$text{'6014'}\"></CENTER></FORM>\n";
	&Footer($MessageFooterFile,"credits");
}

sub Reconfigure {
	&Header("$boardname - $text{'6500'}",$MessageHeaderFile);
	&Header2;
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>$text{'6501'}</STRONG></BIG></BIG>\n";
	print "<P>$text{'6502'} ";
	if ($UseCookies) { print "$text{'6503'}\n"; }
	else { print "$text{'6504'}\n"; }
	print "<FORM METHOD=POST ACTION=\"$DestinationURL\"$BBStargettop>\n";
	print "<INPUT TYPE=HIDDEN NAME=\"KeySearch\" ";
	print "VALUE=\"No\">\n";
	print "<CENTER>";
	unless ($ArchiveOnly) {
		if ($FORM{'ListTime'} =~ /(\d+) ([\w\(\)]+)/) {
			$FORM{'ListTimeA'} = $1;
			$FORM{'ListTimeB'} = $2;
		}
		else {
			$FORM{'ListTimeA'} = 2;
			$FORM{'ListTimeB'} = "$text{'0062'}";
		}
		if ($UseCookies) {
			print "<P><EM>$text{'6505'}:</EM>";
			print "<BR><INPUT TYPE=RADIO NAME=ListSize VALUE=Recent";
			unless ($FORM{'ListTime'} eq "New Only") {
				print " CHECKED";
			}
			print "> $text{'6506'} ";
		}
		else {
			print "<P>$text{'6507'} ";
		}
		print "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=\"ListTimeA\" SIZE=2 ";
		print "VALUE=$FORM{'ListTimeA'}> ";
		print "<SELECT NAME=\"ListTimeB\"><OPTION";
		if ($FORM{'ListTimeB'} eq "$text{'0060'}") {
			print " SELECTED";
		}
		print ">$text{'0060'}<OPTION";
		if ($FORM{'ListTimeB'} eq "$text{'0061'}") {
			print " SELECTED";
		}
		print ">$text{'0061'}<OPTION";
		if ($FORM{'ListTimeB'} eq "$text{'0062'}") {
			print " SELECTED";
		}
		print ">$text{'0062'}<OPTION";
		if ($FORM{'ListTimeB'} eq "$text{'0063'}") {
			print " SELECTED";
		}
		print ">$text{'0063'}</SELECT></FONT>\n";
		if ($UseCookies) {
			print "<BR><INPUT TYPE=RADIO NAME=ListSize VALUE=New";
			if ($FORM{'ListTime'} eq "New Only") {
				print " CHECKED";
			}
			print "> $text{'6508'}\n";
		}
	}
	print "<P>$text{'6509'}: <FONT FACE=\"Courier\"><SELECT NAME=\"ListType\"><OPTION";
	if ($AlphaSortMessages) {
		print " VALUE=\"Alphabetically\"";
		if ($FORM{'ListType'} eq "Alphabetically") {
			print " SELECTED";
		}
		print ">$text{'6603'}<OPTION VALUE=\"Alphabetically, Reversed\"";
		if ($FORM{'ListType'} eq "Alphabetically, Reversed") {
			print " SELECTED";
		}
		print ">$text{'6604'}";
	}
	else {
		print " VALUE=\"Chronologically\"";
		if ((($FORM{'ListType'} =~ /Chronologically/)
		  || ($FORM{'ListType'} =~ /Guestbook/))
		  && ($FORM{'ListType'} !~ /Threaded/)
		  && ($FORM{'ListType'} !~ /Compressed/)) {
			print " SELECTED";
		}
		print ">$text{'6601'}<OPTION VALUE=\"By Threads\"";
		if ($FORM{'ListType'} =~ /Thread/) {
			print " SELECTED";
		}
		print ">$text{'6602'}";
		unless ($AdminRun) {
			print "<OPTION VALUE=\"Compressed\"";
			if ($FORM{'ListType'} =~ /Compressed/) {
				print " SELECTED";
			}
			print ">$text{'6609'}";
			print "</SELECT></FONT>\n";
			print "<BR>$text{'6510'}: <FONT FACE=\"Courier\">";
			print "<SELECT NAME=\"ListDisplay\">";
			print "<OPTION VALUE=\"Single\"";
			unless ($FORM{'ListType'} =~ /Guestbook/) {
				print " SELECTED";
			}
			print ">$text{'6607'}<OPTION VALUE=\"Guestbook\"";
			if ($FORM{'ListType'} =~ /Guestbook/) {
				print " SELECTED";
			}
			print ">$text{'6608'}";
		}
		print "</SELECT></FONT>\n";
		print "<BR>$text{'6511'}: <FONT FACE=\"Courier\">";
		print "<SELECT NAME=\"ListSort\"><OPTION";
		print " VALUE=\"Standard\"";
		if (($FORM{'ListType'} !~ /Reversed/)
		  && ($FORM{'ListType'} !~ /Mixed/)
		  && ($FORM{'ListType'} !~ /UBB/)) {
			print " SELECTED";
		}
		print ">$text{'6610'}<OPTION VALUE=\"Reversed\"";
		if ($FORM{'ListType'} =~ /Reversed/) {
			print " SELECTED";
		}
		print ">$text{'6611'}<OPTION VALUE=\"Mixed\"";
		if ($FORM{'ListType'} =~ /Mixed/) {
			print " SELECTED";
		}
		print ">$text{'6612'}<OPTION VALUE=\"UBB\"";
		if ($FORM{'ListType'} =~ /UBB/) {
			print " SELECTED";
		}
		print ">$text{'6613'}";
	}
	print "</SELECT></FONT>\n";
	if ($AllowFramesChoice) {
		print "<P>$text{'6710'}: ";
		print "<INPUT TYPE=RADIO NAME=\"UseFrames\" ";
		print "VALUE=\"Yes\"";
		if (!($Cookies{'UseFrames'}) || ($Cookies{'UseFrames'} eq "Yes")) {
			print " CHECKED";
		}
		print "> $text{'1519'} ";
		print "<INPUT TYPE=RADIO NAME=\"UseFrames\" ";
		print "VALUE=\"No\"";
		if ($Cookies{'UseFrames'} && ($Cookies{'UseFrames'} ne "Yes")) {
			print " CHECKED";
		}
		print "> $text{'1520'}\n";
	}
	if ($UseCookies) {
		print "<P><TABLE $tablespec><TR>\n";
		print "<TH COLSPAN=2>$TableCellStart<BIG>$text{'6700'}";
		print "</BIG></FONT></TH></TR><TR><TD COLSPAN=2>$TableCellStart";
		print "<HR WIDTH=75% NOSHADE></FONT></TR><TR>\n";
		print "<TH ALIGN=RIGHT>$TableCellStart";
		print "$text{'1510'}:</FONT></TH>";
		print "<TD>$TableInputCellStart";
		if (!($AdminRun) && $LockRemoteUser && $ENV{'REMOTE_USER'}) {
			print "<INPUT TYPE=HIDDEN NAME=\"name\" ";
			print " VALUE=\"$ENV{'REMOTE_USER'}\">";
			print "<STRONG>$ENV{'REMOTE_USER'}</STRONG>";
		}
		else {
			print "<INPUT TYPE=TEXT NAME=\"name\" ";
			print "SIZE=$InputLength MAXLENGTH=$MaxInputLength";
			if ($Cookies{'name'}) {
				print " VALUE=\"$Cookies{'name'}\"";
			}
			print ">";
		}
		print "</FONT></TD></TR><TR>\n";
		print "<TH ALIGN=RIGHT>$TableCellStart";
		print "$text{'1511'}:";
		print "</FONT></TH><TD>$TableInputCellStart";
		if (!($AdminRun) && $email && $RequireEmail) {
			if ($DisplayEmail && $email) { print "<STRONG>$email</STRONG>"; }
			else { print "<STRONG>Private!</STRONG>"; }
		}
		else {
			print "<INPUT TYPE=TEXT NAME=\"email\" ";
			print "SIZE=$InputLength MAXLENGTH=100";
			if ($Cookies{'email'}) {
				print " VALUE=\"$Cookies{'email'}\"";
			}
			print ">";
		}
		print "</FONT></TD></TR><TR>\n";
		if ($SaveLinkInfo) {
			if ($AllowURLs) {
				print "<TH ALIGN=RIGHT>$TableCellStart";
				print "$text{'1515'}:</FONT></TH>";
				print "<TD>$TableInputCellStart<INPUT TYPE=TEXT ";
				print "NAME=\"url\" SIZE=$InputLength MAXLENGTH=250";
				if ($Cookies{'linkurl'}) {
					print " VALUE=\"$Cookies{'linkurl'}\"";
				}
				else {
					print " VALUE=\"http://\"";
				}
				print "></FONT></TD></TR><TR>\n";
				print "<TH ALIGN=RIGHT>$TableCellStart";
				print "$text{'1516'}:</FONT></TH>";
				print "<TD>$TableInputCellStart<INPUT TYPE=TEXT ";
				print "NAME=\"url_title\" SIZE=$InputLength MAXLENGTH=$MaxInputLength";
				if ($Cookies{'linkname'}) {
					print " VALUE=\"$Cookies{'linkname'}\"";
				}
				print "></FONT></TD></TR><TR>\n";
			}
			if ($AllowPics) {
				print "<TH ALIGN=RIGHT>$TableCellStart";
				print "$text{'1517'}:</FONT></TH>";
				print "<TD>$TableInputCellStart<INPUT TYPE=TEXT ";
				print "NAME=\"imageurl\" SIZE=$InputLength MAXLENGTH=250";
				if ($Cookies{'imageurl'}) {
					print " VALUE=\"$Cookies{'imageurl'}\"";
				}
				else {
					print " VALUE=\"http://\"";
				}
				print "></FONT></TD></TR><TR>\n";
			}
		}
		if ($AllowUserDeletion || $UserProfileDir) {
			print "<TH ALIGN=RIGHT>$TableCellStart";
			print "$text{'0205'}:</FONT></TH>";
			print "<TD>$TableInputCellStart<INPUT TYPE=PASSWORD NAME=\"password\"";
			if ($FORM{'password'}) {
				print " VALUE=\"$FORM{'password'}\"";
			}
			print " SIZE=$InputLength></FONT></TD></TR><TR>\n";
			print "<TH ALIGN=RIGHT>$TableCellStart";
			print "$text{'6720'}:</FONT></TH>";
			print "<TD>$TableInputCellStart";
			print "<INPUT TYPE=RADIO NAME=\"CookiePW\" ";
			print "VALUE=\"Yes\"";
			if ($FORM{'password'}) { print " CHECKED"; }
			print "> $text{'1519'} ";
			print "<INPUT TYPE=RADIO NAME=\"CookiePW\" ";
			print "VALUE=\"No\"";
			unless ($FORM{'password'}) { print " CHECKED"; }
			print "> $text{'1520'}";
			print "</FONT></TD></TR><TR>\n";
		}
		print "</TR></TABLE>\n";
	}
	print "<P><INPUT TYPE=SUBMIT NAME=\"ResetConfig\" ";
	print "VALUE=\"$text{'5001'}\"></CENTER></FORM>\n";
	print "<P><EM>$text{'5000'}</EM>\n";
	&Footer($MessageFooterFile,"credits");
}

sub UpdateAddressList {
	unless ($email) {
		&Error("9300","9301");
	}
	unless (-w "$dir") { &Error("9410","9411"); }
	&LockOpen (LIST,"$dir/addresses.txt");
	@list = <LIST>;
	$listcheck = 0;
	seek (LIST, 0, 0);
	foreach $address (@list) {
		if ($address =~ /$email/i) {
			if ($FORM{'action'} eq "delete") {
				&Error("9850","9851");
				$listcheck = 1;
			}
			else {
				&Error("9700","9701");
				print LIST "$address";
				$listcheck = 1;
			}
		}
		else {
			print LIST "$address";
		}
	}
	if ($listcheck < 1) {
		if ($FORM{'action'} eq "delete") {
			&Error("9750","9751");
		}
		else {
			&Error("9800","9801");
			print LIST "$email\n";
		}
	}
	truncate (LIST, tell(LIST));
	&LockClose (LIST,"$dir/addresses.txt");
	&Footer($MessageFooterFile,"return");
}

1;
