#!/usr/local/bin/perl

use strict;

binmode STDOUT;

eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \

  chdir "$1";
};

require "sproxy.ini";

my %data = &ParseInput();

my $cmd = $data{'cmd'};

my %escapes;

if ( ($cmd eq 'ver') || ($cmd eq 'blankform') || ($cmd eq 'frm') || (($cmd eq '') && ($data{'doc'} eq '')) || ($cmd eq 'init') || ($cmd eq 'sp_func') || ($cmd eq 'show') || ($cmd eq 'opts') || ($cmd eq 'unload') || ($cmd eq 'acheck') || ($cmd eq 'rdrct') || ($cmd eq 'chk_fr') ) {
##############################################################################
	$data{'msg_srv_isnot_available'}= $::msg_srv_isnot_available;
	$data{'msg_text_has_error'}	= $::msg_text_has_error;
	$data{'schema_url'} = $::schema_url;
	$data{'spp_langs'} = $::spp_langs;

	$data{'spch_js_path'}	= $::spch_js_path;
	$data{'sproxy_url'}	= $::sproxy_url;
	$data{'def_lang'}	= $::def_lang;
	$data{'def_enabled'}	= $::def_enabled;
	$data{'def_timeout'}	= $::def_timeout;
	$data{'opt_bg_cl'}	= $::opt_bg_cl;
	$data{'auto_hide'}	= $::auto_hide;
	$data{'main_server'}	= $::main_server;
	$data{'second_servers'}	= $::second_servers;
	$data{'exptime'}	= $::exptime;

	$data{'doc_process'}	= 'script/ssrv.cgi';
	$data{'spell_script'}	= "http://$data{'main_server'}$data{'doc_process'}";
	$data{'achk_ver'}	= 'sproxy.(Perl) v.1.01.09 (c) SpellChecker.Net 2000,2001';

	my @achk_path		= split(/(\/)|(\\)/,$0);
	$data{'achk_file'}	= $achk_path[$#achk_path];

	$data{'self_name'}	= $data{'sproxy_url'};

	my @pararr		= split(/:/, get_cookie('acpars'));
	$data{'lang'}		= $pararr[0] || $data{'def_lang'};
	$data{'timeout'}	= $pararr[1] || $data{'def_timeout'};
	$data{'enabled'}	= $pararr[2] || $data{'def_enabled'};

	$data{'text'}		=~ s/&/&amp;/g;
	$data{'text'}		=~ s/\"/&quot;/g;
	$data{'text'}		=~ s/\r/&#13;/g;
	$data{'text'}		=~ s/\n/&#10;/g;
	$data{'text'}		=~ s/\t/&#9;/g;

	$data{'ch_f_name'}	= "chfr_x_1";
	$data{'sp_f_name'}	= "spfr_x_2";
	$data{'op_w_name'}	= "opwd_x_3";
##############################################################################
	$data{'framesetbeg'} 	= '<frameset onload="javascript: doLoad();" onunload="javascript: doUnload();" cols="0,0" frameborder="No" framespacing=0 border=0 bgcolor=#FFFFFF>';
	$data{'framesetend'}	= '</frameset>';
	$data{'framebeg'}	= '<frame name';
	$data{'frameend'}	= 'marginwidth="0" marginheight="0" noresize scrolling="no" frameborder="no" framespacing=0>';
	$data{'frameref'}	= 'frames';
##############################################################################
	$data{'msrvr'}		= $data{'main_server'};
	$data{'scndsrvr'}	= $data{'second_servers'};

	if ($data{'cmd'} eq 'init') {
		$data{'cur_mainsrv'} = get_cookie('cursrv') || $data{'main_server'};

		if ($data{'second_servers'} eq '') {
			if ($data{'cur_mainsrv'} ne $data{'main_server'}) {
				$data{'second_servers'} = $data{'main_server'};
			}
		} else {
			$data{'second_servers'} = $data{'main_server'} . ';' . $data{'second_servers'};
		}

		$data{'second_servers'}	=~ s/$data{'cur_mainsrv'}//gi;
		$data{'second_servers'}	=~ s/(;+)/;/g;
		$data{'second_servers'}	=~ s/^;//;
		$data{'second_servers'}	=~ s/;$//;

		$data{'main_server'}	= $data{'cur_mainsrv'};
	}
##############################################################################
}
##############################################################################
$::pathtospfolder =~ s'^/*''g;
$::pathtospfolder =~ s'/*$'';
if ($::pathtospfolder ne '') {
	$::pathtospfolder = '/'.$::pathtospfolder;
}
$data{'pathtospfolder'} = $::pathtospfolder;

$data{'def_ssrv_host'}	= '';
$data{'def_ssrv_port'}	= 80;
$data{'def_ssrv_path'}	= $data{'pathtospfolder'}.'/spellcheck/script/ssrv.cgi';

my $DOC_BLANK		= $data{'pathtospfolder'}.'/spellcheck/lf/blank.html';
my $DOC_BLANKFORM	= $data{'pathtospfolder'}.'/spellcheck/lf/blankform.html';

$data{'ssrv_host'} = $data{'ssrv_host'} || $data{'def_ssrv_host'};
$data{'ssrv_port'} = $data{'ssrv_port'} || $data{'def_ssrv_port'};
$data{'ssrv_path'} = $data{'ssrv_path'} || $data{'def_ssrv_path'};

my $err_no		= 'No errors.';
my $err_nohost		= 'Host not found.';
my $err_server_invalid	= 'Invalid server.';
my $err_socket		= 'Socket creation error.';
my $err_connect		= 'Connection failed.';
##############################################################################
if ($data{'debug'} ne '') {
	&printHeader();
}

my $ParseTmplt = 1;
my $template;

if ($cmd eq 'blankform') {
	&Do2Links();
	$template = 'blankform.tmpl';
}
elsif ($cmd eq 'frm') {
	&DoFrm();
	$template = 'frameset.tmpl';
}
elsif ($cmd eq 'ver') {
	$template	= "<html><head></head><body><b>$data{'achk_ver'}</b><br>SCRIPT FILENAME: $data{'achk_file'}</body></html>";
	$ParseTmplt	= 0;
}
elsif ($cmd eq 'init')
{	$template	= 'init.tmpl';		}
elsif ($cmd eq 'sp_func')
{	$template	= 'dospell.tmpl'	}
elsif ($cmd eq 'show')
{	$template	= 'show.tmpl';		}
elsif ($cmd eq 'opts')
{	$template	= 'opts.tmpl';		}
elsif ($cmd eq 'unload')
{	$template	= 'unload.tmpl';	}
elsif ($cmd eq 'acheck')
{	&DoCheck();				} 
elsif ($cmd eq 'rdrct')
{	$template	= 'result.tmpl';	}
elsif ($cmd eq 'chk_fr')
{	$template	= 'result.tmpl';	}
elsif ( ($cmd ne '') || ($data{'doc'} ne '') )
{	&DoCheck();				}
else
{	if ($data{'result'} ne '')
	{	$template	= 'result.tmpl';}
	else
	{	
		$template	= "<html><head></head><body></body></html>";
		$ParseTmplt	= 0;
	}
}
##############################################################################
if ($cmd ne 'acheck') {
	&printHeader();
}
if ($ParseTmplt == 1) {
	&PrintTemplate($template, %data);
} else {
	print $template;
}
##############################################################################
sub urlenc()
{
	my($text) = @_;
	$text =~ s/([^A-Za-z0-9\-_.])/$escapes{$1}/g;
	$text;
}
##############################################################################
sub printHeader() {
	print "Content-type: text/html; charset=UTF-8\n";
	print "Expires: Tue Jan 1 00:00:00 1980 GMT;\n";
	print "Pragma: no-cache;\n";
	print "Cache-Control: no-cache;\n\n";
}
##############################################################################
sub Do2Links() {
	if ($data{'hide'} =~ /\[cp\]/) {
		$data{'twolink'} = '<br><a href="" onclick="parent.opener.parent.cTL.focus(); parent.close()">Abort SpellChecker</a>&nbsp;&nbsp;';
		$data{'twolink'} .= '<a href="" onclick="parent.opener.parent.cTL.form.submit(); parent.opener.focus(); document.location = parent.opener.service_host+parent.opener.doc_process+\'?ssrv_host=\'+parent.opener.ssrv_host+\'&cmd=eos&customerid=\'+parent.opener.customerid+\'&sessionid=0&hide=\'+parent.opener.hide;';
#		$data{'twolink'} .= '<a href="" onclick="parent.opener.parent.cTL.form.submit(); parent.opener.focus(); document.location = parent.opener.service_host+parent.opener.doc_process+\'?ssrv_host=\'+parent.opener.ssrv_host+\'&cmd=eos&customerid=\'+parent.opener.customerid+\'&sessionid=0&hide=\'+parent.opener.hide+\'';
#		$data{'twolink'} .= '&bnr=\'+parent.opener.bnr+\'&schema=\'+parent.opener.schema;';
		$data{'twolink'} .= 'return false">Send Without Checking</a>';
	}
}
##############################################################################
sub DoFrm() {
	if ($data{'qw'} ne '') {
		$data{'qw'} = "var qw = '$data{'qw'}'";
	}
	if ($data{'fifthframe'} ne '') {
		$data{'fifthframe'} = '<frame name="unload" src="'.$data{'self_name'}.'?cmd=unload" marginwidth=1 marginheight=1 noresize scrolling="no" frameborder="no" framespacing=0>';
		$data{'fifthframeh'} = ',0';
	}
}
##############################################################################
# get_cookie()
#	Gets cookie by name
##############################################################################
sub get_cookie() {
	my ($name) = @_;

	$name=&cookie_scrub($name);
	my $temp=$ENV{'HTTP_COOKIE'};
	my @pairs=split(/\; /,$temp);
	my %clist;
	my $sets;
	foreach $sets (@pairs) {
		my ($key,$value)=split(/=/,$sets);
		$clist{$key} = $value;
	}
	my $retval=$clist{$name};

	return $retval;
}

sub cookie_scrub() {
	my($retval) = @_;

	$retval=~s/\;//;
	$retval=~s/\=//;

	return $retval;
}
##############################################################################
# DoCheck()
#	Checks entered text and server availability.
#	It is used by the ping routine.
##############################################################################
sub DoCheck() {
	my $get = '';

	for (0..255) {
	    $escapes{chr($_)} = sprintf("%%%02X", $_);
	}

	my $code;
	if ($cmd eq 'acheck') {
		$code = ' 302 ';

		$get = "customerid=" . &urlenc($data{'customerid'}) . 
				"&lang=" . &urlenc($data{'lang'}) . 
				"&text=" . &urlenc($data{'text'}) . 
				"&cmd=check&trg_url=" . &urlenc($data{'trg_url'}) . 
				"&frameid=" . &urlenc($data{'frameid'});
	} else {
		$code = ' 200 ';

		if ($data{'doc'} ne '') {
			if ($data{'doc'} eq 'blank') 
				{ $data{'ssrv_path'} = $DOC_BLANK; }
			elsif ($data{'doc'} eq 'blankform')
				{ $data{'ssrv_path'} = $DOC_BLANKFORM; }
		} else {
			my $f;
			foreach $f (keys %data) {
				if ( ($f ne 'def_ssrv_host') && ($f ne 'def_ssrv_port') && ($f ne 'def_ssrv_path') && ($f ne 'ssrv_port') && ($f ne 'ssrv_path') && ($f ne 'pathtospfolder') && ($f ne 'msg_srv_isnot_available') && ($f ne 'msg_text_has_error') && ($f ne 'pathtospfolder') && ($f ne 'schema_url') && ($f ne 'spp_langs') ) {
					if ($get ne '') {$get .= '&'}
					$get .= $f . '=' . &urlenc($data{$f});
				}
			}
		}

	}

	my $result = &CheckServer($data{'ssrv_host'}, $data{'ssrv_port'}, $data{'ssrv_path'}, $get, $code);

	if ($data{'debug'} ne '') {
		print '</pre><hr>ERROR_CODE:'.$result; 
		exit();
	}

	if ($cmd ne 'acheck') { exit(); }

	if ($result ne $err_no) {
		&printHeader();
		&PrintTemplate('check.tmpl', %data);
	}
	exit();
}

sub CheckServer() {
	my ($host, $port, $ssrv, $get, $code) = @_;
	use Socket;

	if ($data{'debug'} ne '') {
		print '<html><body><pre>';

		if ($get eq '') {
			print "GET";
		} else {
			print "POST";
		}
		print " http://$host:$port$ssrv HTTP/1.0\n<br>";
		print "Accept: */*\n<br>";
		if ($cmd eq 'acheck') {
			print "User-Agent: Auto SpellCheck. Pinger\n<br>";
		} else {
			print "User-Agent: $ENV{'HTTP_USER_AGENT'}\n<br>";
		}
		if ($get ne '') {
			print "Content-Length: ".length($get)."\n<br>";
		}
		print "Pragma: no-cache\n<br>";
		print "Cookie: $ENV{'HTTP_COOKIE'}\n<br>";
		print "\n<br>";
		if ($get ne '') {
			print "$get\n<br>";
			print "\n<br>";
		}
		print '</pre><hr>';
		print '<pre>';
	}
	my $iaddr=inet_aton($host) || { return $err_nohost };

	my $hostaddr=sockaddr_in($port, $iaddr);

	my $proto = getprotobyname('tcp');

	if ( !defined($hostaddr) ) { return $err_server_invalid }

	if ( !socket(S, PF_INET, SOCK_STREAM, $proto) ) { return $err_socket }

	if ( !connect(S, $hostaddr) ) { close S; return $err_connect }

	my($oldfh) = select(S); $| = 1; select($oldfh);

	if ($get eq '') {
		print S "GET";
	} else {
		print S "POST";
	}
	print S " http://$host:$port$ssrv HTTP/1.0\n";
	print S "Accept: */*\n";
	if ($cmd eq 'acheck') {
		print S "User-Agent: Auto SpellCheck. Pinger\n";
	} else {
		print S "User-Agent: $ENV{'HTTP_USER_AGENT'}\n";
	}
	if ($get ne '') {
		print S "Content-Length: ".length($get)."\n";
	}
	print S "Pragma: no-cache\n";
	print S "Cookie: $ENV{'HTTP_COOKIE'}\n";
	print S "\n";
	if ($get ne '') {
		print S "$get\n";
		print S "\n";
	}

	my $http_header = <S>;
	if ($data{'debug'} ne '') { print $http_header; }
	
	while (<S>) {
		if ($data{'debug'} ne '') { s/</&lt;/g; }
		print $_;
	}

	s/\n//g;
	s/\r//g;

	if ( index($http_header, $code) == -1 ) {
		close S;
		return substr($http_header,9,3);
	}
	close S;
	return $err_no;
}
#########################################################################
# ParseInput()
#    Parses the input and returns all parameters as a hash.
#    Deletes all blackslashes and single quotes from the security reasons
#########################################################################
sub ParseInput() {
	(*fval) = @_ if @_ ;

	my $buf;
	my %field;
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN,$buf,$ENV{'CONTENT_LENGTH'});
	}
	else {
		$buf=$ENV{'QUERY_STRING'};
	}
	if ($buf eq "") {
            return 0;
		}
	else {
 		my @fval=split(/&/,$buf);
		my $i;
		foreach $i (0 .. $#fval){
			my ($name,$val)=split (/=/,$fval[$i],2);
			$val=~tr/+/ /;
			$val=~ s/%(..)/pack("c",hex($1))/ge;
			$val=~ s/\\//g;
			$val=~ s/\`//g;
			$name=~tr/+/ /;
			$name=~ s/%(..)/pack("c",hex($1))/ge;
			$name=~ s/\\//g;
			$name=~ s/\`//g;

			if (!defined($field{$name})) {
				$field{$name}=$val;
			}
			else {
				$field{$name} .= ",$val";
			}
	   }
	}
return %field;
}
#########################################################################
# PrintError
#    Prints error message
#########################################################################
sub PrintError() {
	my ($msg) = @_;
	print "$msg";
	exit();
}
#########################################################################
# PrintTemplate($template, %data)
#    Prints the $template page replacing <#something#> constructions with 
#    parameters from %data
#########################################################################
sub PrintTemplate() {
	($template, %data) = @_;
	if (!$template) {&PrintError("No template given.");}
	open (TPL, $template) or &PrintError("Cannot open template '$template'.");
	while (<TPL>) {
		s/<#(\w+)#>/$data{$1}/g;
		print;
	}
	close TPL or &PrintError("Cannot close template.");
}
