############################################
##                                        ##
##                 WebBBS                 ##
##           by Darryl Burgdorf           ##
##       (e-mail burgdorf@awsd.com)       ##
##                                        ##
##             version:  5.00             ##
##        last modified:  11/02/01        ##
##           copyright (c) 2001           ##
##                                        ##
##    latest version is available from    ##
##        http://awsd.com/scripts/        ##
##                                        ##
############################################

# COPYRIGHT NOTICE:
#
# Copyright 2001 Darryl C. Burgdorf.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified by anyone, so long as this copyright notice and the header
# above remain intact, but any usage should be registered.  (See the
# program documentation for registration information.)  Selling the
# code for this program without prior written consent is expressly
# forbidden.  Obtain permission before redistributing this program
# over the Internet or in any other medium.  In all cases copyright
# and header must remain intact.
#
# Certain subroutines and code segments utilized in this program are
# adapted from code written by Kevin Dearing of webjourneymen.net
# and dacpro.com, and are used with permission.
#
# This program is distributed "as is" and without warranty of any
# kind, either express or implied.  (Some states do not allow the
# limitation or exclusion of liability for incidental or consequential
# damages, so this notice may not apply to you.)  In no event shall
# the liability of Darryl C. Burgdorf and/or Affordable Web Space
# Design for any damages, losses and/or causes of action exceed the
# total amount paid by the user for this software.

###################
## GENERAL NOTES ##
###################

# In the sections below, define the configuration variables which
# will determine how your forum(s) will look and function.  If you're
# running more than one forum, this file should contain the "default"
# settings common to the majority; specific settings can, of course,
# be redefined in the configuration files for specific forums, in
# cases where you don't want them all behaving identically.

##############################################
## You MUST define the following variables! ##
##############################################

## (1) Specify the locations of your WebBBS files:

$scripts_dir = "/usr/foo/cgi-bin";

$webbbs_basic = "$scripts_dir/webbbs_basic.pl";
$webbbs_form = "$scripts_dir/webbbs_form.pl";
$webbbs_index = "$scripts_dir/webbbs_index.pl";
$webbbs_misc = "$scripts_dir/webbbs_misc.pl";
$webbbs_post = "$scripts_dir/webbbs_post.pl";
$webbbs_profile = "$scripts_dir/webbbs_profile.pl";
$webbbs_read = "$scripts_dir/webbbs_read.pl";
$webbbs_rebuild = "$scripts_dir/webbbs_rebuild.pl";
$webbbs_text = "$scripts_dir/webbbs_text.pl";

## (2) Define your e-mail notification features:

$mailprog = '/usr/sbin/sendmail';
$WEB_SERVER = "";
$SMTP_SERVER = "";

$admin_name = "Administrator";
$maillist_address = "forum\@foo.com";
$notification_address = "admin\@foo.com";
$email_list = 0;
$private_list = 0;

$HeaderOnly = 0;

# use Socket;
# use Net::SMTP;

#################################################################
## You MAY define the following variables, but do not have to! ##
#################################################################

## (3) Tailor the appearance and functionality of your BBS:

$SearchFriendlyURLs = 0;

$DBMType = 0;

$SpellCheckerID = "0532115747";
$SpellCheckerPath = "/cgi-bin/sproxy.cgi";
$SpellCheckerJS = "http://foo.com/spch.js";
$SpellCheckerLang = "en";

$UserProfileDir = "";
$ProfileColumns = 3;
$UserProfilePicsDir = "";
$UserProfilePicsURL = "";
$MaxGraphicSize = 20;

$ListAllProfiles = 0;

$MetaFile = "";
$HeaderFile = "/usr/foo/header.txt";
$FooterFile = "/usr/foo/footer.txt";
$MessageHeaderFile = "";
$MessageFooterFile = "";

$bodyspec = "BGCOLOR=\"#ffffff\" TEXT=\"#000000\"";
$fontspec = "FACE=\"Arial\"";
$navbarspec = "BORDER=0 CELLSPACING=0 CELLPADDING=6 BGCOLOR=\"#eeeeee\"";
$navbarfontspec = "FACE=\"Arial\"";
$navbaropen = " <NOBR>[ ";
$navbarclose = " ]</NOBR> ";
$tablespec = "BORDER=0 CELLSPACING=0 CELLPADDING=3 BGCOLOR=\"#eeeeee\"";
$tablefontspec = "FACE=\"Arial\"";

$PrepostMessage = "";

$ListBullets = 0;

@SubjectPrefixes = ();

$MessageOpenCode = "<BLOCKQUOTE><FONT COLOR=\"#333333\">";
$MessageCloseCode = "</FONT></BLOCKQUOTE>";

$NewOpenCode = "<EM><FONT COLOR=\"#cc0000\">NEW:</FONT></EM>";
$NewCloseCode = "";
$AdminOpenCode = "<EM><FONT COLOR=\"#990000\">ADMIN!</FONT></EM>";
$AdminCloseCode = "";

$UseLocking = 1;
$RefreshTime = 5;

$UseFrames = "";
$BBSFrame = "_parent";
$WelcomePage = "";

$Moderated = 0;
$SearchURL = "";

$TopNPosters = 0;

%Navbar_Links = ();

$SepPostFormIndex = 1;
$SepPostFormRead = 1;

$DefaultType = "By Threads, Mixed";
$DefaultTime = "2 Week(s)";

$AlphaSortMessages = 0;

$printboardname = 1;

$DateConfig = "";
$IndexEntryLines = 2;

$InputColumns = 50;
$InputRows = 10;

$HourOffset = 0;

$ArchiveOnly = 0;
$SingleLineBreaks = 1;

$AutoQuote = 0;
$AutoQuoteChar = ":";

$AutoHotlink = 0;

%SmileyCode = ();

%FormatCode = ();

$NM_Telltale = "*NM*";
$Pic_Telltale = "*PIC*";

$ThreadSpacer = "";

$GuestbookOpen = "<P><CENTER><TABLE BORDER=1 CELLPADDING=6><TR><TD>";
$GuestbookClose = "</TD></TR></TABLE></CENTER>";

$DisplayEmail = 1;
$ResolveIPs = 1;
$DisplayIPs = 0;
$DisplayViews = 1;

$UseCookies = 1;
$IsolateCookies = 0;

$SessionTime = 30;

## (4) Define your visitors' capabilities:

$MaxMessageSize = 50;
$MaxInputLength = 50;

$LockRemoteUser = 0;

$RequireProfile = 0;
$RequireEmail = 0;

$AllowUserDeletion = 0;
$AllowEmailNotices = 1;
$AllowPreview = 1;

$AllowHTML = 0;
$AllowURLs = 0;
$AllowPics = 0;

$AllowProfileHTML = 0;
$AllowProfileURLs = 1;
$AllowProfilePics = 1;

$SaveLinkInfo = 0;

$AllowUserPrefs = 1;
$AllowNewThreads = 1;
$AllowResponses = 1;

$NaughtyWordsFile = "";
$CensorPosts = 0;

$ShowPosterIP = 1;
$BannedIPsFile = "";
$BanLevel = 1;

###################################################################
## If necessary, set up the WebAdverts configuration subroutine! ##
###################################################################

sub insertadvert {
	local($adzone) = @_;
	$ADVNoPrint = 1;
	if ($adzone) { $ADVQuery = "zone=$adzone"; }
	else { $ADVQuery = ""; }
	require "/usr/foo/cgi-bin/ads.pl";
}

#######################################
## Do NOT remove the following line! ##
#######################################

1;
